/* TerminalWidget.c generated by valac 0.56.18, the Vala compiler
 * generated from TerminalWidget.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2011-2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3, as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <vte/vte.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <handy.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <sys/wait.h>
#include <poll.h>
#include <pcre2.h>
#include <glib/gstdio.h>

#define TERMINAL_TERMINAL_WIDGET_DEFAULT_LABEL _ ("Terminal")
#define TERMINAL_TERMINAL_WIDGET_ACTION_COPY "term.copy"
#define TERMINAL_TERMINAL_WIDGET_ACTION_COPY_OUTPUT "term.copy-output"
#define TERMINAL_TERMINAL_WIDGET_ACTION_CLEAR_SCREEN "term.clear-screen"
#define TERMINAL_TERMINAL_WIDGET_ACTION_RESET "term.reset"
#define TERMINAL_TERMINAL_WIDGET_ACTION_PASTE "term.paste"
#define TERMINAL_TERMINAL_WIDGET_ACTION_RELOAD "term.reload"
#define TERMINAL_TERMINAL_WIDGET_ACTION_SCROLL_TO_COMMAND "term.scroll-to-command"
#define TERMINAL_TERMINAL_WIDGET_ACTION_SELECT_ALL "term.select-all"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_DEFAULT "term.zoom::default"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_IN "term.zoom::in"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_OUT "term.zoom::out"
#define TERMINAL_TERMINAL_WIDGET_SEND_PROCESS_FINISHED_BASH "dbus-send --type=method_call " "--session --dest=io.elementary.terminal " "/io/elementary/terminal " "io.elementary.terminal.ProcessFinished " "string:$PANTHEON_TERMINAL_ID " "string:\"$(fc -nl -1 | cut -c 3-)\" " "int32:\$__bp_last_ret_value >/dev/null 2>&1"
#define TERMINAL_TERMINAL_WIDGET_USERCHARS "-[:alnum:]"
#define TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "[" TERMINAL_TERMINAL_WIDGET_USERCHARS "]"
#define TERMINAL_TERMINAL_WIDGET_PASSCHARS_CLASS "[-[:alnum:]\\Q,?;.:/!%$^*&~\"#'\\E]"
#define TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "[-[:alnum:]]"
#define TERMINAL_TERMINAL_WIDGET_HOST TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "+(\\." TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "+)*"
#define TERMINAL_TERMINAL_WIDGET_PORT "(?:\\:[[:digit:]]{1,5})?"
#define TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "[-[:alnum:]\\Q_$.+!*,;:@&=?/~#%\\E]"
#define TERMINAL_TERMINAL_WIDGET_PATHTERM_CLASS "[^\\Q]'.}>) \t\r\n,\"\\E]"
#define TERMINAL_TERMINAL_WIDGET_SCHEME "(?:news:|telnet:|nntp:|file:\\/|https?:|ftps?:|sftp:|webcal:" "|irc:|sftp:|ldaps?:|nfs:|smb:|rsync:|ssh:|rlogin:|telnet:|git:" "|git\\+ssh:|bzr:|bzr\\+ssh:|svn:|svn\\+ssh:|hg:|mailto:|magnet:)"
#define TERMINAL_TERMINAL_WIDGET_USERPASS TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "+(?:" TERMINAL_TERMINAL_WIDGET_PASSCHARS_CLASS "+)?"
#define TERMINAL_TERMINAL_WIDGET_URLPATH "(?:(/" TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "+(?:[(]" TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "*[)])*" TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "*)*" TERMINAL_TERMINAL_WIDGET_PATHTERM_CLASS ")?"
#define TERMINAL_TERMINAL_WIDGET_MIN_SCALE 0.25
#define TERMINAL_TERMINAL_WIDGET_MAX_SCALE 4.0
#define TERMINAL_TERMINAL_WIDGET_SYS_PIDFD_OPEN 434
#define TERMINAL_MAIN_WINDOW_ACTION_OPEN_IN_BROWSER "action-open-in-browser"
#define TERMINAL_THEMES_PALETTE_SIZE 19
#define TERMINAL_THEMES_DARK "dark"
#define TERMINAL_THEMES_LIGHT "solarized-light"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gboolean (*_LocalFunc0_) (guint keyval, guint code, gpointer user_data);

#define TERMINAL_TYPE_TERMINAL_WIDGET (terminal_terminal_widget_get_type ())
#define TERMINAL_TERMINAL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget))
#define TERMINAL_TERMINAL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidgetClass))
#define TERMINAL_IS_TERMINAL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL_WIDGET))
#define TERMINAL_IS_TERMINAL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL_WIDGET))
#define TERMINAL_TERMINAL_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidgetClass))

typedef struct _TerminalTerminalWidget TerminalTerminalWidget;
typedef struct _TerminalTerminalWidgetClass TerminalTerminalWidgetClass;
typedef struct _TerminalTerminalWidgetPrivate TerminalTerminalWidgetPrivate;

#define TERMINAL_TYPE_MAIN_WINDOW (terminal_main_window_get_type ())
#define TERMINAL_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindow))
#define TERMINAL_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindowClass))
#define TERMINAL_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_MAIN_WINDOW))
#define TERMINAL_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_MAIN_WINDOW))
#define TERMINAL_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindowClass))

typedef struct _TerminalMainWindow TerminalMainWindow;
typedef struct _TerminalMainWindowClass TerminalMainWindowClass;
enum  {
	TERMINAL_TERMINAL_WIDGET_0_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_PROGRAM_STRING_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_MAIN_WINDOW_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_NUM_PROPERTIES
};
static GParamSpec* terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_NUM_PROPERTIES];
typedef enum  {
	TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST,
	TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING,
	TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT
} TerminalTerminalWidgetDropTargets;

#define TERMINAL_TERMINAL_WIDGET_TYPE_DROP_TARGETS (terminal_terminal_widget_drop_targets_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG (terminal_foreground_process_dialog_get_type ())
#define TERMINAL_FOREGROUND_PROCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG, TerminalForegroundProcessDialog))
#define TERMINAL_FOREGROUND_PROCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG, TerminalForegroundProcessDialogClass))
#define TERMINAL_IS_FOREGROUND_PROCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG))
#define TERMINAL_IS_FOREGROUND_PROCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG))
#define TERMINAL_FOREGROUND_PROCESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG, TerminalForegroundProcessDialogClass))

typedef struct _TerminalForegroundProcessDialog TerminalForegroundProcessDialog;
typedef struct _TerminalForegroundProcessDialogClass TerminalForegroundProcessDialogClass;

#define TERMINAL_TYPE_UNSAFE_PASTE_DIALOG (terminal_unsafe_paste_dialog_get_type ())
#define TERMINAL_UNSAFE_PASTE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG, TerminalUnsafePasteDialog))
#define TERMINAL_UNSAFE_PASTE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG, TerminalUnsafePasteDialogClass))
#define TERMINAL_IS_UNSAFE_PASTE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG))
#define TERMINAL_IS_UNSAFE_PASTE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG))
#define TERMINAL_UNSAFE_PASTE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG, TerminalUnsafePasteDialogClass))

typedef struct _TerminalUnsafePasteDialog TerminalUnsafePasteDialog;
typedef struct _TerminalUnsafePasteDialogClass TerminalUnsafePasteDialogClass;
typedef struct _Block3Data Block3Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vte_regex_unref0(var) ((var == NULL) ? NULL : (var = (vte_regex_unref (var), NULL)))

#define TERMINAL_TYPE_APPLICATION (terminal_application_get_type ())
#define TERMINAL_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplication))
#define TERMINAL_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))
#define TERMINAL_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))

typedef struct _TerminalApplication TerminalApplication;
typedef struct _TerminalApplicationClass TerminalApplicationClass;
typedef struct _Block4Data Block4Data;
enum  {
	TERMINAL_TERMINAL_WIDGET_CWD_CHANGED_SIGNAL,
	TERMINAL_TERMINAL_WIDGET_NUM_SIGNALS
};
static guint terminal_terminal_widget_signals[TERMINAL_TERMINAL_WIDGET_NUM_SIGNALS] = {0};

struct _TerminalTerminalWidget {
	VteTerminal parent_instance;
	TerminalTerminalWidgetPrivate * priv;
	gchar* terminal_id;
	HdyTabPage* tab;
	gchar* link_uri;
	gint default_size;
	gboolean last_key_was_return;
};

struct _TerminalTerminalWidgetClass {
	VteTerminalClass parent_class;
};

struct _TerminalTerminalWidgetPrivate {
	gchar* _current_working_directory;
	gchar* _program_string;
	gboolean init_complete;
	gboolean _resized;
	GPid child_pid;
	TerminalMainWindow* _main_window;
	gboolean _child_has_exited;
	gboolean _killed;
	GtkClipboard* clipboard;
	GSimpleAction* copy_action;
	GSimpleAction* copy_output_action;
	GSimpleAction* clear_screen_action;
	GSimpleAction* reset_action;
	GSimpleAction* paste_action;
	GSimpleAction* scroll_to_command_action;
	glong remembered_position;
	glong remembered_command_start_row;
	glong remembered_command_end_row;
	GtkEventControllerMotion* motion_controller;
	GtkEventControllerScroll* scroll_controller;
	GtkEventControllerKey* key_controller;
	GtkGestureMultiPress* primary_gesture;
	GtkGestureMultiPress* secondary_gesture;
	gboolean modifier_pressed;
	gdouble scroll_delta;
};

struct _Block3Data {
	int _ref_count_;
	TerminalTerminalWidget* self;
	TerminalUnsafePasteDialog* dialog;
	gchar* text;
};

struct _Block4Data {
	int _ref_count_;
	TerminalTerminalWidget* self;
	gulong once;
};

static gint TerminalTerminalWidget_private_offset;
static gpointer terminal_terminal_widget_parent_class = NULL;
static gint terminal_terminal_widget_terminal_id_counter;
static gint terminal_terminal_widget_terminal_id_counter = 0;
VALA_EXTERN GSettings* terminal_application_settings;

VALA_EXTERN GType terminal_terminal_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminalWidget, g_object_unref)
VALA_EXTERN GType terminal_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalMainWindow, g_object_unref)
static GType terminal_terminal_widget_drop_targets_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN TerminalTerminalWidget* terminal_terminal_widget_new (TerminalMainWindow* parent_window);
VALA_EXTERN TerminalTerminalWidget* terminal_terminal_widget_construct (GType object_type,
                                                            TerminalMainWindow* parent_window);
static void terminal_terminal_widget_pointer_focus (TerminalTerminalWidget* self);
static void terminal_terminal_widget_secondary_released (TerminalTerminalWidget* self,
                                                  GtkGestureMultiPress* gesture,
                                                  gint n_press,
                                                  gdouble x,
                                                  gdouble y);
static gchar* terminal_terminal_widget_get_link (TerminalTerminalWidget* self,
                                          GdkEvent* event);
static void terminal_terminal_widget_popup_context_menu (TerminalTerminalWidget* self,
                                                  GdkRectangle* rect);
static void terminal_terminal_widget_primary_pressed (TerminalTerminalWidget* self,
                                               GtkGestureMultiPress* gesture,
                                               gint n_press,
                                               gdouble x,
                                               gdouble y);
VALA_EXTERN TerminalMainWindow* terminal_terminal_widget_get_main_window (TerminalTerminalWidget* self);
VALA_EXTERN GSimpleAction* terminal_main_window_get_simple_action (TerminalMainWindow* self,
                                                       const gchar* action);
static void terminal_terminal_widget_scroll (TerminalTerminalWidget* self,
                                      gdouble x,
                                      gdouble y);
static gboolean terminal_terminal_widget_key_pressed (TerminalTerminalWidget* self,
                                               guint keyval,
                                               guint keycode,
                                               GdkModifierType modifiers);
VALA_EXTERN void terminal_terminal_widget_remember_position (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_remember_command_end_position (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_remember_command_start_position (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_get_resized (TerminalTerminalWidget* self);
VALA_EXTERN gchar* terminal_terminal_widget_get_last_output (TerminalTerminalWidget* self,
                                                 gboolean include_command);
static gboolean __lambda31_ (TerminalTerminalWidget* self,
                      guint keyval,
                      guint code);
static gboolean ___lambda31___localfunc0_ (guint keyval,
                                    guint code,
                                    gpointer self);
static void terminal_terminal_widget_action_reset (TerminalTerminalWidget* self);
static void terminal_terminal_widget_action_clear_screen (TerminalTerminalWidget* self);
static void terminal_terminal_widget_setup_menu (TerminalTerminalWidget* self);
static void __lambda30_ (TerminalTerminalWidget* self,
                  GtkClipboard* clipboard,
                  GdkAtom* atoms,
                  gint atoms_length1);
static void ___lambda30__gtk_clipboard_targets_received_func (GtkClipboard* clipboard,
                                                       GdkAtom* atoms,
                                                       gint n_atoms,
                                                       gpointer self);
VALA_EXTERN void terminal_main_window_update_context_menu (TerminalMainWindow* self);
VALA_EXTERN GMenu* terminal_main_window_get_context_menu_model (TerminalMainWindow* self);
static void terminal_terminal_widget_real_copy_clipboard (VteTerminal* base);
static void terminal_terminal_widget_copy_output (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_confirm_kill_fg_process (TerminalTerminalWidget* self,
                                                           const gchar* primary_text,
                                                           const gchar* button_label);
VALA_EXTERN gboolean terminal_terminal_widget_has_foreground_process (TerminalTerminalWidget* self);
VALA_EXTERN GType terminal_foreground_process_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalForegroundProcessDialog, g_object_unref)
VALA_EXTERN TerminalForegroundProcessDialog* terminal_foreground_process_dialog_new (TerminalMainWindow* parent,
                                                                         const gchar* primary_text,
                                                                         const gchar* button_label);
VALA_EXTERN TerminalForegroundProcessDialog* terminal_foreground_process_dialog_construct (GType object_type,
                                                                               TerminalMainWindow* parent,
                                                                               const gchar* primary_text,
                                                                               const gchar* button_label);
VALA_EXTERN void terminal_terminal_widget_kill_fg (TerminalTerminalWidget* self);
static void terminal_terminal_widget_real_paste_clipboard (VteTerminal* base);
static void __lambda32_ (TerminalTerminalWidget* self,
                  GtkClipboard* clipboard,
                  const gchar* text);
static void terminal_terminal_widget_validated_feed (TerminalTerminalWidget* self,
                                              const gchar* text);
static void ___lambda32__gtk_clipboard_text_received_func (GtkClipboard* clipboard,
                                                    const gchar* text,
                                                    gpointer self);
VALA_EXTERN GType terminal_unsafe_paste_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalUnsafePasteDialog, g_object_unref)
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN gboolean terminal_utils_is_safe_paste (const gchar* text,
                                       gchar** msg);
VALA_EXTERN TerminalUnsafePasteDialog* terminal_unsafe_paste_dialog_new (TerminalMainWindow* parent,
                                                             const gchar* title_text,
                                                             const gchar* text_to_paste);
VALA_EXTERN TerminalUnsafePasteDialog* terminal_unsafe_paste_dialog_construct (GType object_type,
                                                                   TerminalMainWindow* parent,
                                                                   const gchar* title_text,
                                                                   const gchar* text_to_paste);
static void __lambda33_ (Block3Data* _data3_,
                  gint res);
static void ___lambda33__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void terminal_terminal_widget_update_theme (TerminalTerminalWidget* self);
VALA_EXTERN GdkRGBA* terminal_themes_get_rgba_palette (const gchar* theme,
                                           gint* result_length1);
static GdkRGBA* _vala_array_dup1 (GdkRGBA* self,
                           gssize length);
static void terminal_terminal_widget_update_audible_bell (TerminalTerminalWidget* self);
static void terminal_terminal_widget_update_cursor_shape (TerminalTerminalWidget* self);
static void terminal_terminal_widget_on_child_exited (TerminalTerminalWidget* self);
static void terminal_terminal_widget_set_child_has_exited (TerminalTerminalWidget* self,
                                                    gboolean value);
VALA_EXTERN gboolean terminal_terminal_widget_try_get_foreground_pid (TerminalTerminalWidget* self,
                                                          gint* pid);
VALA_EXTERN void terminal_terminal_widget_term_ps (TerminalTerminalWidget* self);
static void terminal_terminal_widget_set_killed (TerminalTerminalWidget* self,
                                          gboolean value);
VALA_EXTERN void terminal_terminal_widget_active_shell (TerminalTerminalWidget* self,
                                            const gchar* dir);
static void terminal_terminal_widget_check_cwd_changed (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_run_program (TerminalTerminalWidget* self,
                                           const gchar* _program_string,
                                           const gchar* working_directory);
VALA_EXTERN void terminal_terminal_widget_set_program_string (TerminalTerminalWidget* self,
                                                  const gchar* value);
VALA_EXTERN const gchar* terminal_terminal_widget_get_program_string (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_get_child_has_exited (TerminalTerminalWidget* self);
VALA_EXTERN gint terminal_terminal_widget_calculate_width (TerminalTerminalWidget* self,
                                               gint column_count);
VALA_EXTERN gint terminal_terminal_widget_calculate_height (TerminalTerminalWidget* self,
                                                gint row_count);
static void terminal_terminal_widget_clickable (TerminalTerminalWidget* self,
                                         gchar** str,
                                         gint str_length1);
VALA_EXTERN gchar* terminal_terminal_widget_get_shell_location (TerminalTerminalWidget* self);
static void terminal_terminal_widget_real_increase_font_size (VteTerminal* base);
static void terminal_terminal_widget_real_decrease_font_size (VteTerminal* base);
VALA_EXTERN void terminal_terminal_widget_default_font_size (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_is_init_complete (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_set_init_complete (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_drag_received (TerminalTerminalWidget* self,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             GtkSelectionData* selection_data,
                                             guint target_type,
                                             guint time_);
VALA_EXTERN gchar* terminal_utils_sanitize_path (const gchar* _path,
                                     const gchar* shell_location,
                                     gboolean add_file_scheme);
VALA_EXTERN void terminal_terminal_widget_set_resized (TerminalTerminalWidget* self,
                                           gboolean value);
static void terminal_terminal_widget_scroll_to_command (TerminalTerminalWidget* self,
                                                 GSimpleAction* action,
                                                 GVariant* parameter);
VALA_EXTERN void terminal_terminal_widget_reload (TerminalTerminalWidget* self);
VALA_EXTERN const gchar* terminal_terminal_widget_get_current_working_directory (TerminalTerminalWidget* self);
static void terminal_terminal_widget_set_current_working_directory (TerminalTerminalWidget* self,
                                                             const gchar* value);
VALA_EXTERN void terminal_terminal_widget_set_main_window (TerminalTerminalWidget* self,
                                               TerminalMainWindow* value);
VALA_EXTERN GType terminal_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalApplication, g_object_unref)
static TerminalApplication* terminal_terminal_widget_get_app (TerminalTerminalWidget* self);
VALA_EXTERN TerminalApplication* terminal_main_window_get_app (TerminalMainWindow* self);
VALA_EXTERN const gchar* terminal_terminal_widget_get_tab_label (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_set_tab_label (TerminalTerminalWidget* self,
                                             const gchar* value);
VALA_EXTERN gboolean terminal_terminal_widget_get_killed (TerminalTerminalWidget* self);
static GObject * terminal_terminal_widget_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _terminal_terminal_widget_update_theme_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _terminal_terminal_widget_update_audible_bell_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _terminal_terminal_widget_update_theme_g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void _terminal_terminal_widget_update_cursor_shape_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _terminal_terminal_widget_pointer_focus_gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                                                gdouble x,
                                                                                gdouble y,
                                                                                gpointer self);
static void _terminal_terminal_widget_scroll_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                          gdouble dx,
                                                                          gdouble dy,
                                                                          gpointer self);
static void _terminal_terminal_widget___lambda34_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda34__gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                                    gpointer self);
static gboolean _terminal_terminal_widget_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                     guint keyval,
                                                                                     guint keycode,
                                                                                     GdkModifierType state,
                                                                                     gpointer self);
static void _terminal_terminal_widget___lambda35_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda35__gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                                   guint keyval,
                                                                                   guint keycode,
                                                                                   GdkModifierType state,
                                                                                   gpointer self);
static void _terminal_terminal_widget___lambda36_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda36__gtk_event_controller_key_focus_out (GtkEventControllerKey* _sender,
                                                                                gpointer self);
static gboolean _terminal_terminal_widget___lambda37_ (TerminalTerminalWidget* self);
static gboolean __terminal_terminal_widget___lambda37__gtk_event_controller_key_modifiers (GtkEventControllerKey* _sender,
                                                                                    GdkModifierType object,
                                                                                    gpointer self);
static void _terminal_terminal_widget_primary_pressed_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                                gint n_press,
                                                                                gdouble x,
                                                                                gdouble y,
                                                                                gpointer self);
static void _terminal_terminal_widget_secondary_released_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                    gint n_press,
                                                                                    gdouble x,
                                                                                    gdouble y,
                                                                                    gpointer self);
static gboolean _gtk_event_controller_handle_event_gtk_widget_event (GtkWidget* _sender,
                                                              GdkEvent* event,
                                                              gpointer self);
static void _terminal_terminal_widget___lambda38_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda38__vte_terminal_selection_changed (VteTerminal* _sender,
                                                                            gpointer self);
static void _terminal_terminal_widget___lambda39_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda39__gtk_widget_size_allocate (GtkWidget* _sender,
                                                                      GtkAllocation* allocation,
                                                                      gpointer self);
static void _terminal_terminal_widget_check_cwd_changed_vte_terminal_contents_changed (VteTerminal* _sender,
                                                                                gpointer self);
static void _terminal_terminal_widget_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                          gint status,
                                                                          gpointer self);
static void _terminal_terminal_widget___lambda40_ (Block4Data* _data4_);
static void _terminal_terminal_widget_setup_menu_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                      GdkEventOwnerChange* event,
                                                                      gpointer self);
static void __terminal_terminal_widget___lambda40__gtk_widget_realize (GtkWidget* _sender,
                                                                gpointer self);
static void _vala_array_add1 (GtkTargetEntry* * array,
                       gint* length,
                       gint* size,
                       const GtkTargetEntry* value);
static void _vala_array_add2 (GtkTargetEntry* * array,
                       gint* length,
                       gint* size,
                       const GtkTargetEntry* value);
static void _vala_array_add3 (GtkTargetEntry* * array,
                       gint* length,
                       gint* size,
                       const GtkTargetEntry* value);
static void _terminal_terminal_widget_drag_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                            GdkDragContext* context,
                                                                            gint x,
                                                                            gint y,
                                                                            GtkSelectionData* selection_data,
                                                                            guint info,
                                                                            guint time_,
                                                                            gpointer self);
static void _terminal_terminal_widget___lambda41_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda41__g_simple_action_activate (GSimpleAction* _sender,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void _terminal_terminal_widget_copy_output_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void _terminal_terminal_widget_action_clear_screen_g_simple_action_activate (GSimpleAction* _sender,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void _terminal_terminal_widget_action_reset_g_simple_action_activate (GSimpleAction* _sender,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void _terminal_terminal_widget___lambda42_ (TerminalTerminalWidget* self);
static void __terminal_terminal_widget___lambda42__g_simple_action_activate (GSimpleAction* _sender,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void _terminal_terminal_widget_reload_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self);
static void _terminal_terminal_widget_scroll_to_command_g_simple_action_activate (GSimpleAction* _sender,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void _vte_terminal_select_all_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self);
static void _terminal_terminal_widget___lambda43_ (TerminalTerminalWidget* self,
                                            GVariant* p);
static gchar* _variant_get1 (GVariant* value);
static void __terminal_terminal_widget___lambda43__g_simple_action_activate (GSimpleAction* _sender,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void terminal_terminal_widget_finalize (GObject * obj);
static GType terminal_terminal_widget_get_type_once (void);
static void _vala_terminal_terminal_widget_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_terminal_terminal_widget_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_COPY[2] = {"<Control><Shift>C", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_COPY_OUTPUT[2] = {"<Alt>C", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_CLEAR_SCREEN[2] = {"<Control><Shift>L", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_RESET[2] = {"<Control><Shift>K", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_PASTE[2] = {"<Control><Shift>V", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_RELOAD[3] = {"<Control><Shift>R", "<Ctrl>F5", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_SCROLL_TO_COMMAND[2] = {"<Alt>Up", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_SELECT_ALL[2] = {"<Control><Shift>A", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_DEFAULT[3] = {"<control>0", "<Control>KP_0", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_IN[4] = {"<Control>plus", "<Control>equal", "<Control>KP_Add", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_OUT[3] = {"<Control>minus", "<Control>KP_Subtract", NULL};
static const gchar* TERMINAL_TERMINAL_WIDGET_REGEX_STRINGS[5] = {TERMINAL_TERMINAL_WIDGET_SCHEME "//(?:" TERMINAL_TERMINAL_WIDGET_USERPASS "\\@)?" TERMINAL_TERMINAL_WIDGET_HOST TERMINAL_TERMINAL_WIDGET_PORT TERMINAL_TERMINAL_WIDGET_URLPATH, "(?:www|ftp)" TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "*\\." TERMINAL_TERMINAL_WIDGET_HOST TERMINAL_TERMINAL_WIDGET_PORT TERMINAL_TERMINAL_WIDGET_URLPATH, "(?:callto:|h323:|sip:)" TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "[" TERMINAL_TERMINAL_WIDGET_USERCHARS ".]*(?:" TERMINAL_TERMINAL_WIDGET_PORT "/[a-z0-9]+)?\\@" TERMINAL_TERMINAL_WIDGET_HOST, "(?:mailto:)?" TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "[" TERMINAL_TERMINAL_WIDGET_USERCHARS ".]*\\@" TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "+\\." TERMINAL_TERMINAL_WIDGET_HOST, "(?:news:|man:|info:)[[:alnum:]\\Q^_{|}~!\"#$%&'()*+,./;:=?`\\E]+"};

static inline gpointer
terminal_terminal_widget_get_instance_private (TerminalTerminalWidget* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalTerminalWidget_private_offset);
}

static GType
terminal_terminal_widget_drop_targets_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST, "TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST", "urilist"}, {TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING, "TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING", "string"}, {TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT, "TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT", "text"}, {0, NULL, NULL}};
	GType terminal_terminal_widget_drop_targets_type_id;
	terminal_terminal_widget_drop_targets_type_id = g_enum_register_static ("TerminalTerminalWidgetDropTargets", values);
	return terminal_terminal_widget_drop_targets_type_id;
}

static GType
terminal_terminal_widget_drop_targets_get_type (void)
{
	static volatile gsize terminal_terminal_widget_drop_targets_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_widget_drop_targets_type_id__once)) {
		GType terminal_terminal_widget_drop_targets_type_id;
		terminal_terminal_widget_drop_targets_type_id = terminal_terminal_widget_drop_targets_get_type_once ();
		g_once_init_leave (&terminal_terminal_widget_drop_targets_type_id__once, terminal_terminal_widget_drop_targets_type_id);
	}
	return terminal_terminal_widget_drop_targets_type_id__once;
}

TerminalTerminalWidget*
terminal_terminal_widget_construct (GType object_type,
                                    TerminalMainWindow* parent_window)
{
	TerminalTerminalWidget * self = NULL;
#line 164 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (parent_window != NULL, NULL);
#line 165 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) g_object_new (object_type, "main-window", parent_window, NULL);
#line 164 "../src/Widgets/TerminalWidget.vala"
	return self;
#line 607 "TerminalWidget.c"
}

TerminalTerminalWidget*
terminal_terminal_widget_new (TerminalMainWindow* parent_window)
{
#line 164 "../src/Widgets/TerminalWidget.vala"
	return terminal_terminal_widget_construct (TERMINAL_TYPE_TERMINAL_WIDGET, parent_window);
#line 615 "TerminalWidget.c"
}

static void
terminal_terminal_widget_pointer_focus (TerminalTerminalWidget* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 323 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 325 "../src/Widgets/TerminalWidget.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 325 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 325 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_allow_hyperlink ((VteTerminal*) self, _tmp1_);
#line 631 "TerminalWidget.c"
}

static void
terminal_terminal_widget_secondary_released (TerminalTerminalWidget* self,
                                             GtkGestureMultiPress* gesture,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y)
{
	GdkEvent* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GdkRectangle _tmp4_ = {0};
#line 328 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 329 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, NULL);
#line 329 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = terminal_terminal_widget_get_link (self, _tmp0_);
#line 329 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->link_uri);
#line 329 "../src/Widgets/TerminalWidget.vala"
	self->link_uri = _tmp1_;
#line 331 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->link_uri;
#line 331 "../src/Widgets/TerminalWidget.vala"
	if (_tmp2_ != NULL) {
#line 661 "TerminalWidget.c"
		GSimpleAction* _tmp3_;
#line 332 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = self->priv->copy_action;
#line 332 "../src/Widgets/TerminalWidget.vala"
		g_simple_action_set_enabled (_tmp3_, TRUE);
#line 667 "TerminalWidget.c"
	}
#line 335 "../src/Widgets/TerminalWidget.vala"
	_tmp4_.x = (gint) x;
#line 335 "../src/Widgets/TerminalWidget.vala"
	_tmp4_.y = (gint) y;
#line 335 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_popup_context_menu (self, &_tmp4_);
#line 337 "../src/Widgets/TerminalWidget.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 677 "TerminalWidget.c"
}

static void
terminal_terminal_widget_primary_pressed (TerminalTerminalWidget* self,
                                          GtkGestureMultiPress* gesture,
                                          gint n_press,
                                          gdouble x,
                                          gdouble y)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 340 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 341 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->link_uri);
#line 341 "../src/Widgets/TerminalWidget.vala"
	self->link_uri = NULL;
#line 342 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_get_allow_hyperlink ((VteTerminal*) self);
#line 342 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 342 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_) {
#line 703 "TerminalWidget.c"
		GdkEvent* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_;
#line 343 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, NULL);
#line 343 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = terminal_terminal_widget_get_link (self, _tmp2_);
#line 343 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (self->link_uri);
#line 343 "../src/Widgets/TerminalWidget.vala"
		self->link_uri = _tmp3_;
#line 345 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = self->link_uri;
#line 345 "../src/Widgets/TerminalWidget.vala"
		if (_tmp5_ != NULL) {
#line 345 "../src/Widgets/TerminalWidget.vala"
			_tmp4_ = !vte_terminal_get_has_selection ((VteTerminal*) self);
#line 722 "TerminalWidget.c"
		} else {
#line 345 "../src/Widgets/TerminalWidget.vala"
			_tmp4_ = FALSE;
#line 726 "TerminalWidget.c"
		}
#line 345 "../src/Widgets/TerminalWidget.vala"
		if (_tmp4_) {
#line 730 "TerminalWidget.c"
			TerminalMainWindow* _tmp6_;
			GSimpleAction* _tmp7_;
			GSimpleAction* _tmp8_;
#line 346 "../src/Widgets/TerminalWidget.vala"
			_tmp6_ = self->priv->_main_window;
#line 346 "../src/Widgets/TerminalWidget.vala"
			_tmp7_ = terminal_main_window_get_simple_action (_tmp6_, TERMINAL_MAIN_WINDOW_ACTION_OPEN_IN_BROWSER);
#line 346 "../src/Widgets/TerminalWidget.vala"
			_tmp8_ = _tmp7_;
#line 346 "../src/Widgets/TerminalWidget.vala"
			g_signal_emit_by_name (_tmp8_, "activate", NULL);
#line 346 "../src/Widgets/TerminalWidget.vala"
			_g_object_unref0 (_tmp8_);
#line 744 "TerminalWidget.c"
		}
	} else {
#line 349 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_set_allow_hyperlink ((VteTerminal*) self, TRUE);
#line 749 "TerminalWidget.c"
	}
}

static void
terminal_terminal_widget_scroll (TerminalTerminalWidget* self,
                                 gdouble x,
                                 gdouble y)
{
#line 353 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_delta = self->priv->scroll_delta + y;
#line 357 "../src/Widgets/TerminalWidget.vala"
	if (self->priv->scroll_delta >= 0.5) {
#line 358 "../src/Widgets/TerminalWidget.vala"
		g_signal_emit_by_name ((VteTerminal*) self, "decrease-font-size");
#line 359 "../src/Widgets/TerminalWidget.vala"
		self->priv->scroll_delta = 0.0;
#line 768 "TerminalWidget.c"
	} else {
#line 360 "../src/Widgets/TerminalWidget.vala"
		if (self->priv->scroll_delta <= (-0.5)) {
#line 361 "../src/Widgets/TerminalWidget.vala"
			g_signal_emit_by_name ((VteTerminal*) self, "increase-font-size");
#line 362 "../src/Widgets/TerminalWidget.vala"
			self->priv->scroll_delta = 0.0;
#line 776 "TerminalWidget.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 421 "../src/Widgets/TerminalWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 786 "TerminalWidget.c"
}

static gboolean
__lambda31_ (TerminalTerminalWidget* self,
             guint keyval,
             guint code)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkKeymap* keymap = NULL;
	GdkDisplay* _tmp0_;
	GdkKeymap* _tmp1_;
	GdkKeymap* _tmp2_;
	GdkKeymap* _tmp3_;
	GdkKeymapKey* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gboolean result;
#line 421 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 421 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = gdk_keymap_get_for_display (_tmp0_);
#line 421 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 421 "../src/Widgets/TerminalWidget.vala"
	keymap = _tmp2_;
#line 422 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = keymap;
#line 422 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = gdk_keymap_get_entries_for_keyval (_tmp3_, keyval, &_tmp4_, &_tmp5_);
#line 422 "../src/Widgets/TerminalWidget.vala"
	keys = (g_free (keys), NULL);
#line 422 "../src/Widgets/TerminalWidget.vala"
	keys = _tmp4_;
#line 422 "../src/Widgets/TerminalWidget.vala"
	keys_length1 = _tmp5_;
#line 422 "../src/Widgets/TerminalWidget.vala"
	_keys_size_ = keys_length1;
#line 422 "../src/Widgets/TerminalWidget.vala"
	if (_tmp6_) {
#line 828 "TerminalWidget.c"
		GdkKeymapKey* _tmp7_;
		gint _tmp7__length1;
#line 423 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = keys;
#line 423 "../src/Widgets/TerminalWidget.vala"
		_tmp7__length1 = keys_length1;
#line 835 "TerminalWidget.c"
		{
			GdkKeymapKey* key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 423 "../src/Widgets/TerminalWidget.vala"
			key_collection = _tmp7_;
#line 423 "../src/Widgets/TerminalWidget.vala"
			key_collection_length1 = _tmp7__length1;
#line 423 "../src/Widgets/TerminalWidget.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 847 "TerminalWidget.c"
				GdkKeymapKey key = {0};
#line 423 "../src/Widgets/TerminalWidget.vala"
				key = key_collection[key_it];
#line 851 "TerminalWidget.c"
				{
					GdkKeymapKey _tmp8_;
#line 424 "../src/Widgets/TerminalWidget.vala"
					_tmp8_ = key;
#line 424 "../src/Widgets/TerminalWidget.vala"
					if (code == _tmp8_.keycode) {
#line 425 "../src/Widgets/TerminalWidget.vala"
						result = TRUE;
#line 425 "../src/Widgets/TerminalWidget.vala"
						_g_object_unref0 (keymap);
#line 425 "../src/Widgets/TerminalWidget.vala"
						keys = (g_free (keys), NULL);
#line 425 "../src/Widgets/TerminalWidget.vala"
						return result;
#line 866 "TerminalWidget.c"
					}
				}
			}
		}
	}
#line 430 "../src/Widgets/TerminalWidget.vala"
	result = FALSE;
#line 430 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (keymap);
#line 430 "../src/Widgets/TerminalWidget.vala"
	keys = (g_free (keys), NULL);
#line 430 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 880 "TerminalWidget.c"
}

static gboolean
___lambda31___localfunc0_ (guint keyval,
                           guint code,
                           gpointer self)
{
	gboolean result;
	result = __lambda31_ ((TerminalTerminalWidget*) self, keyval, code);
#line 418 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 892 "TerminalWidget.c"
}

static gboolean
terminal_terminal_widget_key_pressed (TerminalTerminalWidget* self,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType modifiers)
{
	_LocalFunc0_ match_keycode = NULL;
	gpointer match_keycode_target;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean result;
#line 366 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 367 "../src/Widgets/TerminalWidget.vala"
	switch (keyval) {
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Control_R:
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Control_L:
#line 918 "TerminalWidget.c"
		{
			GtkEventControllerScroll* _tmp0_;
#line 370 "../src/Widgets/TerminalWidget.vala"
			_tmp0_ = self->priv->scroll_controller;
#line 370 "../src/Widgets/TerminalWidget.vala"
			gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 371 "../src/Widgets/TerminalWidget.vala"
			break;
#line 927 "TerminalWidget.c"
		}
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Return:
#line 931 "TerminalWidget.c"
		{
			GSimpleAction* _tmp1_;
			GSimpleAction* _tmp2_;
#line 374 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_remember_position (self);
#line 375 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = self->priv->scroll_to_command_action;
#line 375 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp1_, TRUE);
#line 376 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_remember_command_end_position (self);
#line 377 "../src/Widgets/TerminalWidget.vala"
			_tmp2_ = self->priv->copy_output_action;
#line 377 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp2_, FALSE);
#line 378 "../src/Widgets/TerminalWidget.vala"
			break;
#line 949 "TerminalWidget.c"
		}
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Up:
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Down:
#line 955 "TerminalWidget.c"
		{
#line 382 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_remember_command_start_position (self);
#line 383 "../src/Widgets/TerminalWidget.vala"
			break;
#line 961 "TerminalWidget.c"
		}
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Menu:
#line 965 "TerminalWidget.c"
		{
			glong col = 0L;
			glong row = 0L;
			glong _tmp3_ = 0L;
			glong _tmp4_ = 0L;
			glong cell_width = 0L;
			glong cell_height = 0L;
			gdouble vadj = 0.0;
			GtkAdjustment* _tmp5_;
			GtkAdjustment* _tmp6_;
			gdouble _tmp7_;
			gdouble _tmp8_;
			GdkRectangle rect = {0};
			GdkRectangle _tmp9_ = {0};
			GdkRectangle _tmp10_;
#line 388 "../src/Widgets/TerminalWidget.vala"
			vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp3_, &_tmp4_);
#line 388 "../src/Widgets/TerminalWidget.vala"
			col = _tmp3_;
#line 388 "../src/Widgets/TerminalWidget.vala"
			row = _tmp4_;
#line 390 "../src/Widgets/TerminalWidget.vala"
			cell_width = vte_terminal_get_char_width ((VteTerminal*) self);
#line 391 "../src/Widgets/TerminalWidget.vala"
			cell_height = vte_terminal_get_char_height ((VteTerminal*) self);
#line 392 "../src/Widgets/TerminalWidget.vala"
			_tmp5_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) self);
#line 392 "../src/Widgets/TerminalWidget.vala"
			_tmp6_ = _tmp5_;
#line 392 "../src/Widgets/TerminalWidget.vala"
			_tmp7_ = gtk_adjustment_get_value (_tmp6_);
#line 392 "../src/Widgets/TerminalWidget.vala"
			_tmp8_ = _tmp7_;
#line 392 "../src/Widgets/TerminalWidget.vala"
			vadj = _tmp8_;
#line 394 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.x = (gint) (col * cell_width);
#line 394 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.y = (gint) ((row - vadj) * cell_height);
#line 394 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.width = (gint) cell_width;
#line 394 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.height = (gint) cell_height;
#line 394 "../src/Widgets/TerminalWidget.vala"
			rect = _tmp9_;
#line 401 "../src/Widgets/TerminalWidget.vala"
			_tmp10_ = rect;
#line 401 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_popup_context_menu (self, &_tmp10_);
#line 402 "../src/Widgets/TerminalWidget.vala"
			break;
#line 1017 "TerminalWidget.c"
		}
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Alt_L:
#line 367 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Alt_R:
#line 1023 "TerminalWidget.c"
		{
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_;
			GSimpleAction* _tmp17_;
#line 407 "../src/Widgets/TerminalWidget.vala"
			_tmp12_ = self->priv->_resized;
#line 407 "../src/Widgets/TerminalWidget.vala"
			if (!_tmp12_) {
#line 1032 "TerminalWidget.c"
				gchar* _tmp13_;
				gchar* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
#line 407 "../src/Widgets/TerminalWidget.vala"
				_tmp13_ = terminal_terminal_widget_get_last_output (self, TRUE);
#line 407 "../src/Widgets/TerminalWidget.vala"
				_tmp14_ = _tmp13_;
#line 407 "../src/Widgets/TerminalWidget.vala"
				_tmp15_ = strlen (_tmp14_);
#line 407 "../src/Widgets/TerminalWidget.vala"
				_tmp16_ = _tmp15_;
#line 407 "../src/Widgets/TerminalWidget.vala"
				_tmp11_ = _tmp16_ > 0;
#line 407 "../src/Widgets/TerminalWidget.vala"
				_g_free0 (_tmp14_);
#line 1049 "TerminalWidget.c"
			} else {
#line 407 "../src/Widgets/TerminalWidget.vala"
				_tmp11_ = FALSE;
#line 1053 "TerminalWidget.c"
			}
#line 407 "../src/Widgets/TerminalWidget.vala"
			_tmp17_ = self->priv->copy_output_action;
#line 407 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp17_, _tmp11_);
#line 408 "../src/Widgets/TerminalWidget.vala"
			break;
#line 1061 "TerminalWidget.c"
		}
		default:
		{
			gboolean _tmp18_ = FALSE;
#line 411 "../src/Widgets/TerminalWidget.vala"
			if (!self->priv->modifier_pressed) {
#line 411 "../src/Widgets/TerminalWidget.vala"
				_tmp18_ = TRUE;
#line 1070 "TerminalWidget.c"
			} else {
#line 411 "../src/Widgets/TerminalWidget.vala"
				_tmp18_ = !((modifiers & gtk_accelerator_get_default_mod_mask ()) == gtk_accelerator_get_default_mod_mask ());
#line 1074 "TerminalWidget.c"
			}
#line 411 "../src/Widgets/TerminalWidget.vala"
			if (_tmp18_) {
#line 412 "../src/Widgets/TerminalWidget.vala"
				terminal_terminal_widget_remember_command_start_position (self);
#line 1080 "TerminalWidget.c"
			}
#line 414 "../src/Widgets/TerminalWidget.vala"
			break;
#line 1084 "TerminalWidget.c"
		}
	}
#line 418 "../src/Widgets/TerminalWidget.vala"
	match_keycode = ___lambda31___localfunc0_;
#line 418 "../src/Widgets/TerminalWidget.vala"
	match_keycode_target = self;
#line 433 "../src/Widgets/TerminalWidget.vala"
	if ((modifiers & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 1093 "TerminalWidget.c"
		GSettings* _tmp20_;
#line 433 "../src/Widgets/TerminalWidget.vala"
		_tmp20_ = terminal_application_settings;
#line 433 "../src/Widgets/TerminalWidget.vala"
		_tmp19_ = g_settings_get_boolean (_tmp20_, "natural-copy-paste");
#line 1099 "TerminalWidget.c"
	} else {
#line 433 "../src/Widgets/TerminalWidget.vala"
		_tmp19_ = FALSE;
#line 1103 "TerminalWidget.c"
	}
#line 433 "../src/Widgets/TerminalWidget.vala"
	if (_tmp19_) {
#line 1107 "TerminalWidget.c"
		_LocalFunc0_ _tmp21_;
		gpointer _tmp21__target;
#line 434 "../src/Widgets/TerminalWidget.vala"
		_tmp21_ = match_keycode;
#line 434 "../src/Widgets/TerminalWidget.vala"
		_tmp21__target = match_keycode_target;
#line 434 "../src/Widgets/TerminalWidget.vala"
		if (_tmp21_ (GDK_KEY_c, keycode, _tmp21__target)) {
#line 435 "../src/Widgets/TerminalWidget.vala"
			if (vte_terminal_get_has_selection ((VteTerminal*) self)) {
#line 436 "../src/Widgets/TerminalWidget.vala"
				vte_terminal_copy_clipboard ((VteTerminal*) self);
#line 437 "../src/Widgets/TerminalWidget.vala"
				if (!((modifiers & GDK_SHIFT_MASK) == GDK_SHIFT_MASK)) {
#line 438 "../src/Widgets/TerminalWidget.vala"
					vte_terminal_unselect_all ((VteTerminal*) self);
#line 1124 "TerminalWidget.c"
				}
#line 440 "../src/Widgets/TerminalWidget.vala"
				result = TRUE;
#line 440 "../src/Widgets/TerminalWidget.vala"
				return result;
#line 1130 "TerminalWidget.c"
			} else {
#line 442 "../src/Widgets/TerminalWidget.vala"
				self->last_key_was_return = TRUE;
#line 1134 "TerminalWidget.c"
			}
		} else {
			gboolean _tmp22_ = FALSE;
			_LocalFunc0_ _tmp23_;
			gpointer _tmp23__target;
#line 444 "../src/Widgets/TerminalWidget.vala"
			_tmp23_ = match_keycode;
#line 444 "../src/Widgets/TerminalWidget.vala"
			_tmp23__target = match_keycode_target;
#line 444 "../src/Widgets/TerminalWidget.vala"
			if (_tmp23_ (GDK_KEY_v, keycode, _tmp23__target)) {
#line 1146 "TerminalWidget.c"
				GtkClipboard* _tmp24_;
#line 444 "../src/Widgets/TerminalWidget.vala"
				_tmp24_ = self->priv->clipboard;
#line 444 "../src/Widgets/TerminalWidget.vala"
				_tmp22_ = gtk_clipboard_wait_is_text_available (_tmp24_);
#line 1152 "TerminalWidget.c"
			} else {
#line 444 "../src/Widgets/TerminalWidget.vala"
				_tmp22_ = FALSE;
#line 1156 "TerminalWidget.c"
			}
#line 444 "../src/Widgets/TerminalWidget.vala"
			if (_tmp22_) {
#line 445 "../src/Widgets/TerminalWidget.vala"
				vte_terminal_paste_clipboard ((VteTerminal*) self);
#line 446 "../src/Widgets/TerminalWidget.vala"
				result = TRUE;
#line 446 "../src/Widgets/TerminalWidget.vala"
				return result;
#line 1166 "TerminalWidget.c"
			}
		}
	}
#line 450 "../src/Widgets/TerminalWidget.vala"
	if ((modifiers & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 450 "../src/Widgets/TerminalWidget.vala"
		_tmp26_ = (modifiers & GDK_SHIFT_MASK) == GDK_SHIFT_MASK;
#line 1174 "TerminalWidget.c"
	} else {
#line 450 "../src/Widgets/TerminalWidget.vala"
		_tmp26_ = FALSE;
#line 1178 "TerminalWidget.c"
	}
#line 450 "../src/Widgets/TerminalWidget.vala"
	if (_tmp26_) {
#line 1182 "TerminalWidget.c"
		_LocalFunc0_ _tmp27_;
		gpointer _tmp27__target;
#line 450 "../src/Widgets/TerminalWidget.vala"
		_tmp27_ = match_keycode;
#line 450 "../src/Widgets/TerminalWidget.vala"
		_tmp27__target = match_keycode_target;
#line 450 "../src/Widgets/TerminalWidget.vala"
		_tmp25_ = _tmp27_ (GDK_KEY_k, keycode, _tmp27__target);
#line 1191 "TerminalWidget.c"
	} else {
#line 450 "../src/Widgets/TerminalWidget.vala"
		_tmp25_ = FALSE;
#line 1195 "TerminalWidget.c"
	}
#line 450 "../src/Widgets/TerminalWidget.vala"
	if (_tmp25_) {
#line 451 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_action_reset (self);
#line 452 "../src/Widgets/TerminalWidget.vala"
		result = TRUE;
#line 452 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 1205 "TerminalWidget.c"
	}
#line 455 "../src/Widgets/TerminalWidget.vala"
	if ((modifiers & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 455 "../src/Widgets/TerminalWidget.vala"
		_tmp29_ = (modifiers & GDK_SHIFT_MASK) == GDK_SHIFT_MASK;
#line 1211 "TerminalWidget.c"
	} else {
#line 455 "../src/Widgets/TerminalWidget.vala"
		_tmp29_ = FALSE;
#line 1215 "TerminalWidget.c"
	}
#line 455 "../src/Widgets/TerminalWidget.vala"
	if (_tmp29_) {
#line 1219 "TerminalWidget.c"
		_LocalFunc0_ _tmp30_;
		gpointer _tmp30__target;
#line 455 "../src/Widgets/TerminalWidget.vala"
		_tmp30_ = match_keycode;
#line 455 "../src/Widgets/TerminalWidget.vala"
		_tmp30__target = match_keycode_target;
#line 455 "../src/Widgets/TerminalWidget.vala"
		_tmp28_ = _tmp30_ (GDK_KEY_l, keycode, _tmp30__target);
#line 1228 "TerminalWidget.c"
	} else {
#line 455 "../src/Widgets/TerminalWidget.vala"
		_tmp28_ = FALSE;
#line 1232 "TerminalWidget.c"
	}
#line 455 "../src/Widgets/TerminalWidget.vala"
	if (_tmp28_) {
#line 456 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_action_clear_screen (self);
#line 457 "../src/Widgets/TerminalWidget.vala"
		result = TRUE;
#line 457 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 1242 "TerminalWidget.c"
	}
#line 460 "../src/Widgets/TerminalWidget.vala"
	if ((modifiers & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 460 "../src/Widgets/TerminalWidget.vala"
		_tmp31_ = keyval == GDK_KEY_Up;
#line 1248 "TerminalWidget.c"
	} else {
#line 460 "../src/Widgets/TerminalWidget.vala"
		_tmp31_ = FALSE;
#line 1252 "TerminalWidget.c"
	}
#line 460 "../src/Widgets/TerminalWidget.vala"
	if (_tmp31_) {
#line 1256 "TerminalWidget.c"
		GSimpleAction* _tmp32_;
		gboolean _tmp33_;
		gboolean _tmp34_;
#line 461 "../src/Widgets/TerminalWidget.vala"
		_tmp32_ = self->priv->scroll_to_command_action;
#line 461 "../src/Widgets/TerminalWidget.vala"
		_tmp33_ = g_action_get_enabled ((GAction*) _tmp32_);
#line 461 "../src/Widgets/TerminalWidget.vala"
		_tmp34_ = _tmp33_;
#line 461 "../src/Widgets/TerminalWidget.vala"
		result = !_tmp34_;
#line 461 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 1270 "TerminalWidget.c"
	}
#line 464 "../src/Widgets/TerminalWidget.vala"
	result = FALSE;
#line 464 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 1276 "TerminalWidget.c"
}

static void
__lambda30_ (TerminalTerminalWidget* self,
             GtkClipboard* clipboard,
             GdkAtom* atoms,
             gint atoms_length1)
{
	gboolean can_paste = FALSE;
	gboolean _tmp0_ = FALSE;
	GSimpleAction* _tmp2_;
#line 469 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (clipboard != NULL);
#line 470 "../src/Widgets/TerminalWidget.vala"
	can_paste = FALSE;
#line 472 "../src/Widgets/TerminalWidget.vala"
	if (atoms != NULL) {
#line 472 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = atoms_length1 > 0;
#line 1296 "TerminalWidget.c"
	} else {
#line 472 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 1300 "TerminalWidget.c"
	}
#line 472 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 1304 "TerminalWidget.c"
		gboolean _tmp1_ = FALSE;
#line 473 "../src/Widgets/TerminalWidget.vala"
		if (gtk_targets_include_text (atoms, (gint) atoms_length1)) {
#line 473 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = TRUE;
#line 1310 "TerminalWidget.c"
		} else {
#line 473 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = gtk_targets_include_uri (atoms, (gint) atoms_length1);
#line 1314 "TerminalWidget.c"
		}
#line 473 "../src/Widgets/TerminalWidget.vala"
		can_paste = _tmp1_;
#line 1318 "TerminalWidget.c"
	}
#line 476 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->priv->paste_action;
#line 476 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp2_, can_paste);
#line 1324 "TerminalWidget.c"
}

static void
___lambda30__gtk_clipboard_targets_received_func (GtkClipboard* clipboard,
                                                  GdkAtom* atoms,
                                                  gint n_atoms,
                                                  gpointer self)
{
#line 469 "../src/Widgets/TerminalWidget.vala"
	__lambda30_ ((TerminalTerminalWidget*) self, clipboard, atoms, n_atoms);
#line 469 "../src/Widgets/TerminalWidget.vala"
	g_object_unref (self);
#line 1337 "TerminalWidget.c"
}

static void
terminal_terminal_widget_setup_menu (TerminalTerminalWidget* self)
{
	GtkClipboard* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean has_output = FALSE;
	GSimpleAction* _tmp7_;
#line 467 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->clipboard;
#line 469 "../src/Widgets/TerminalWidget.vala"
	gtk_clipboard_request_targets (_tmp0_, ___lambda30__gtk_clipboard_targets_received_func, g_object_ref (self));
#line 480 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->priv->_resized;
#line 480 "../src/Widgets/TerminalWidget.vala"
	if (!_tmp2_) {
#line 1358 "TerminalWidget.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 480 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = terminal_terminal_widget_get_last_output (self, TRUE);
#line 480 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = _tmp3_;
#line 480 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = strlen (_tmp4_);
#line 480 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 480 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = _tmp6_ > 0;
#line 480 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp4_);
#line 1375 "TerminalWidget.c"
	} else {
#line 480 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = FALSE;
#line 1379 "TerminalWidget.c"
	}
#line 480 "../src/Widgets/TerminalWidget.vala"
	has_output = _tmp1_;
#line 481 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = self->priv->copy_output_action;
#line 481 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp7_, has_output);
#line 1387 "TerminalWidget.c"
}

static void
terminal_terminal_widget_popup_context_menu (TerminalTerminalWidget* self,
                                             GdkRectangle* rect)
{
	TerminalMainWindow* _tmp0_;
	GtkMenu* context_menu = NULL;
	TerminalMainWindow* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
	GtkWidget* _tmp4_;
	GtkMenu* _tmp5_ = NULL;
	GdkWindow* _tmp6_;
	GdkRectangle _tmp7_;
#line 484 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 484 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (rect != NULL);
#line 485 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_main_window;
#line 485 "../src/Widgets/TerminalWidget.vala"
	terminal_main_window_update_context_menu (_tmp0_);
#line 486 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_setup_menu (self);
#line 489 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->priv->_main_window;
#line 489 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = terminal_main_window_get_context_menu_model (_tmp1_);
#line 489 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _tmp2_;
#line 489 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = _g_object_ref0 ((GtkWidget*) self);
#line 489 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp3_);
#line 489 "../src/Widgets/TerminalWidget.vala"
	g_object_set (_tmp5_, "attach-widget", _tmp4_, NULL);
#line 489 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (_tmp4_);
#line 489 "../src/Widgets/TerminalWidget.vala"
	g_object_ref_sink (_tmp5_);
#line 489 "../src/Widgets/TerminalWidget.vala"
	context_menu = _tmp5_;
#line 492 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = gtk_widget_get_window ((GtkWidget*) self);
#line 492 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = *rect;
#line 492 "../src/Widgets/TerminalWidget.vala"
	gtk_menu_popup_at_rect (context_menu, _tmp6_, &_tmp7_, GDK_GRAVITY_SOUTH_WEST, GDK_GRAVITY_NORTH_WEST, NULL);
#line 484 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (context_menu);
#line 1439 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_copy_clipboard (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 495 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 496 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->link_uri;
#line 496 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_ != NULL) {
#line 496 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = !vte_terminal_get_has_selection ((VteTerminal*) self);
#line 1456 "TerminalWidget.c"
	} else {
#line 496 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 1460 "TerminalWidget.c"
	}
#line 496 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 1464 "TerminalWidget.c"
		GtkClipboard* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = self->priv->clipboard;
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = self->link_uri;
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = self->link_uri;
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = strlen (_tmp4_);
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 497 "../src/Widgets/TerminalWidget.vala"
		gtk_clipboard_set_text (_tmp2_, _tmp3_, _tmp6_);
#line 1482 "TerminalWidget.c"
	} else {
#line 499 "../src/Widgets/TerminalWidget.vala"
		VTE_TERMINAL_CLASS (terminal_terminal_widget_parent_class)->copy_clipboard (G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
#line 1486 "TerminalWidget.c"
	}
}

static void
terminal_terminal_widget_copy_output (TerminalTerminalWidget* self)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	GtkClipboard* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 503 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_get_last_output (self, TRUE);
#line 504 "../src/Widgets/TerminalWidget.vala"
	output = _tmp0_;
#line 505 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->priv->clipboard;
#line 505 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = strlen (output);
#line 505 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _tmp2_;
#line 505 "../src/Widgets/TerminalWidget.vala"
	gtk_clipboard_set_text (_tmp1_, output, _tmp3_);
#line 503 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (output);
#line 1514 "TerminalWidget.c"
}

gboolean
terminal_terminal_widget_confirm_kill_fg_process (TerminalTerminalWidget* self,
                                                  const gchar* primary_text,
                                                  const gchar* button_label)
{
	gboolean result;
#line 508 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 508 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (primary_text != NULL, FALSE);
#line 508 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (button_label != NULL, FALSE);
#line 512 "../src/Widgets/TerminalWidget.vala"
	if (terminal_terminal_widget_has_foreground_process (self)) {
#line 1531 "TerminalWidget.c"
		TerminalForegroundProcessDialog* dialog = NULL;
		GtkWidget* _tmp0_;
		TerminalForegroundProcessDialog* _tmp1_;
		TerminalForegroundProcessDialog* _tmp2_;
#line 513 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 513 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = terminal_foreground_process_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindow), primary_text, button_label);
#line 513 "../src/Widgets/TerminalWidget.vala"
		g_object_ref_sink (_tmp1_);
#line 513 "../src/Widgets/TerminalWidget.vala"
		dialog = _tmp1_;
#line 519 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = dialog;
#line 519 "../src/Widgets/TerminalWidget.vala"
		if (gtk_dialog_run ((GtkDialog*) _tmp2_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1548 "TerminalWidget.c"
			TerminalForegroundProcessDialog* _tmp3_;
#line 520 "../src/Widgets/TerminalWidget.vala"
			_tmp3_ = dialog;
#line 520 "../src/Widgets/TerminalWidget.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp3_);
#line 521 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_kill_fg (self);
#line 1556 "TerminalWidget.c"
		} else {
			TerminalForegroundProcessDialog* _tmp4_;
#line 523 "../src/Widgets/TerminalWidget.vala"
			_tmp4_ = dialog;
#line 523 "../src/Widgets/TerminalWidget.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp4_);
#line 524 "../src/Widgets/TerminalWidget.vala"
			result = FALSE;
#line 524 "../src/Widgets/TerminalWidget.vala"
			_g_object_unref0 (dialog);
#line 524 "../src/Widgets/TerminalWidget.vala"
			return result;
#line 1569 "TerminalWidget.c"
		}
#line 512 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (dialog);
#line 1573 "TerminalWidget.c"
	}
#line 528 "../src/Widgets/TerminalWidget.vala"
	result = TRUE;
#line 528 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 1579 "TerminalWidget.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1616 "TerminalWidget.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1622 "TerminalWidget.c"
}

static void
terminal_terminal_widget_action_clear_screen (TerminalTerminalWidget* self)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 531 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/Widgets/TerminalWidget.vala"
	if (terminal_terminal_widget_has_foreground_process (self)) {
#line 535 "../src/Widgets/TerminalWidget.vala"
		return;
#line 1639 "TerminalWidget.c"
	}
#line 540 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = string_get_data ("clear -x\n", &_tmp1_);
#line 540 "../src/Widgets/TerminalWidget.vala"
	_tmp0__length1 = _tmp1_;
#line 540 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _tmp0_;
#line 540 "../src/Widgets/TerminalWidget.vala"
	_tmp2__length1 = _tmp0__length1;
#line 540 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_feed_child ((VteTerminal*) self, _tmp2_, (gssize) _tmp2__length1);
#line 1651 "TerminalWidget.c"
}

static void
terminal_terminal_widget_action_reset (TerminalTerminalWidget* self)
{
#line 543 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 544 "../src/Widgets/TerminalWidget.vala"
	if (terminal_terminal_widget_confirm_kill_fg_process (self, _ ("Are you sure you want to reset the terminal?"), _ ("Reset"))) {
#line 1661 "TerminalWidget.c"
		guint8* _tmp0_;
		gint _tmp0__length1;
		gint _tmp1_ = 0;
		guint8* _tmp2_;
		gint _tmp2__length1;
#line 550 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = string_get_data ("reset\n", &_tmp1_);
#line 550 "../src/Widgets/TerminalWidget.vala"
		_tmp0__length1 = _tmp1_;
#line 550 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = _tmp0_;
#line 550 "../src/Widgets/TerminalWidget.vala"
		_tmp2__length1 = _tmp0__length1;
#line 550 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_feed_child ((VteTerminal*) self, _tmp2_, (gssize) _tmp2__length1);
#line 1677 "TerminalWidget.c"
	}
}

static void
__lambda32_ (TerminalTerminalWidget* self,
             GtkClipboard* clipboard,
             const gchar* text)
{
#line 555 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (clipboard != NULL);
#line 556 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_validated_feed (self, text);
#line 1690 "TerminalWidget.c"
}

static void
___lambda32__gtk_clipboard_text_received_func (GtkClipboard* clipboard,
                                               const gchar* text,
                                               gpointer self)
{
#line 555 "../src/Widgets/TerminalWidget.vala"
	__lambda32_ ((TerminalTerminalWidget*) self, clipboard, text);
#line 555 "../src/Widgets/TerminalWidget.vala"
	g_object_unref (self);
#line 1702 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_paste_clipboard (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	GtkClipboard* _tmp0_;
#line 554 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 555 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->clipboard;
#line 555 "../src/Widgets/TerminalWidget.vala"
	gtk_clipboard_request_text (_tmp0_, ___lambda32__gtk_clipboard_text_received_func, g_object_ref (self));
#line 1716 "TerminalWidget.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 561 "../src/Widgets/TerminalWidget.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 561 "../src/Widgets/TerminalWidget.vala"
	return _data3_;
#line 1726 "TerminalWidget.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 561 "../src/Widgets/TerminalWidget.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1736 "TerminalWidget.c"
		TerminalTerminalWidget* self;
#line 561 "../src/Widgets/TerminalWidget.vala"
		self = _data3_->self;
#line 561 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (_data3_->dialog);
#line 561 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_data3_->text);
#line 561 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (self);
#line 561 "../src/Widgets/TerminalWidget.vala"
		g_slice_free (Block3Data, _data3_);
#line 1748 "TerminalWidget.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1770 "TerminalWidget.c"
}

static void
__lambda33_ (Block3Data* _data3_,
             gint res)
{
	TerminalTerminalWidget* self;
	TerminalUnsafePasteDialog* _tmp0_;
#line 585 "../src/Widgets/TerminalWidget.vala"
	self = _data3_->self;
#line 586 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = _data3_->dialog;
#line 586 "../src/Widgets/TerminalWidget.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 587 "../src/Widgets/TerminalWidget.vala"
	if (res == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1787 "TerminalWidget.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
		gint _tmp2_ = 0;
		guint8* _tmp3_;
		gint _tmp3__length1;
#line 588 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = string_get_data (_data3_->text, &_tmp2_);
#line 588 "../src/Widgets/TerminalWidget.vala"
		_tmp1__length1 = _tmp2_;
#line 588 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = _tmp1_;
#line 588 "../src/Widgets/TerminalWidget.vala"
		_tmp3__length1 = _tmp1__length1;
#line 588 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_feed_child ((VteTerminal*) self, _tmp3_, (gssize) _tmp3__length1);
#line 1803 "TerminalWidget.c"
	}
}

static void
___lambda33__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 585 "../src/Widgets/TerminalWidget.vala"
	__lambda33_ (self, response_id);
#line 1814 "TerminalWidget.c"
}

static void
terminal_terminal_widget_validated_feed (TerminalTerminalWidget* self,
                                         const gchar* text)
{
	Block3Data* _data3_;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
	gchar* warn_text = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_;
	TerminalMainWindow* toplevel = NULL;
	GtkWidget* _tmp11_;
	TerminalMainWindow* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	TerminalUnsafePasteDialog* _tmp16_;
	TerminalUnsafePasteDialog* _tmp17_;
	TerminalUnsafePasteDialog* _tmp18_;
	TerminalUnsafePasteDialog* _tmp19_;
#line 561 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_data3_->_ref_count_ = 1;
#line 561 "../src/Widgets/TerminalWidget.vala"
	_data3_->self = g_object_ref (self);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = g_strdup (text);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (_data3_->text);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_data3_->text = _tmp0_;
#line 563 "../src/Widgets/TerminalWidget.vala"
	if (_data3_->text == NULL) {
#line 563 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = TRUE;
#line 1856 "TerminalWidget.c"
	} else {
#line 563 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = !g_utf8_validate (_data3_->text, (gssize) -1, NULL);
#line 1860 "TerminalWidget.c"
	}
#line 563 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_) {
#line 564 "../src/Widgets/TerminalWidget.vala"
		block3_data_unref (_data3_);
#line 564 "../src/Widgets/TerminalWidget.vala"
		_data3_ = NULL;
#line 564 "../src/Widgets/TerminalWidget.vala"
		return;
#line 1870 "TerminalWidget.c"
	}
#line 568 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = terminal_application_settings;
#line 568 "../src/Widgets/TerminalWidget.vala"
	if (!g_settings_get_boolean (_tmp2_, "unsafe-paste-alert")) {
#line 1876 "TerminalWidget.c"
		guint8* _tmp3_;
		gint _tmp3__length1;
		gint _tmp4_ = 0;
		guint8* _tmp5_;
		gint _tmp5__length1;
#line 569 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = string_get_data (_data3_->text, &_tmp4_);
#line 569 "../src/Widgets/TerminalWidget.vala"
		_tmp3__length1 = _tmp4_;
#line 569 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = _tmp3_;
#line 569 "../src/Widgets/TerminalWidget.vala"
		_tmp5__length1 = _tmp3__length1;
#line 569 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_feed_child ((VteTerminal*) self, _tmp5_, (gssize) _tmp5__length1);
#line 570 "../src/Widgets/TerminalWidget.vala"
		block3_data_unref (_data3_);
#line 570 "../src/Widgets/TerminalWidget.vala"
		_data3_ = NULL;
#line 570 "../src/Widgets/TerminalWidget.vala"
		return;
#line 1898 "TerminalWidget.c"
	}
#line 577 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = terminal_utils_is_safe_paste (_data3_->text, &_tmp6_);
#line 577 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (warn_text);
#line 577 "../src/Widgets/TerminalWidget.vala"
	warn_text = _tmp6_;
#line 577 "../src/Widgets/TerminalWidget.vala"
	if (_tmp7_) {
#line 1908 "TerminalWidget.c"
		guint8* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_ = 0;
		guint8* _tmp10_;
		gint _tmp10__length1;
#line 578 "../src/Widgets/TerminalWidget.vala"
		_tmp8_ = string_get_data (_data3_->text, &_tmp9_);
#line 578 "../src/Widgets/TerminalWidget.vala"
		_tmp8__length1 = _tmp9_;
#line 578 "../src/Widgets/TerminalWidget.vala"
		_tmp10_ = _tmp8_;
#line 578 "../src/Widgets/TerminalWidget.vala"
		_tmp10__length1 = _tmp8__length1;
#line 578 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_feed_child ((VteTerminal*) self, _tmp10_, (gssize) _tmp10__length1);
#line 579 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (warn_text);
#line 579 "../src/Widgets/TerminalWidget.vala"
		block3_data_unref (_data3_);
#line 579 "../src/Widgets/TerminalWidget.vala"
		_data3_ = NULL;
#line 579 "../src/Widgets/TerminalWidget.vala"
		return;
#line 1932 "TerminalWidget.c"
	}
#line 583 "../src/Widgets/TerminalWidget.vala"
	_tmp11_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 583 "../src/Widgets/TerminalWidget.vala"
	toplevel = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindow);
#line 584 "../src/Widgets/TerminalWidget.vala"
	_tmp12_ = toplevel;
#line 584 "../src/Widgets/TerminalWidget.vala"
	_tmp13_ = warn_text;
#line 584 "../src/Widgets/TerminalWidget.vala"
	_tmp14_ = string_strip (_data3_->text);
#line 584 "../src/Widgets/TerminalWidget.vala"
	_tmp15_ = _tmp14_;
#line 584 "../src/Widgets/TerminalWidget.vala"
	_tmp16_ = terminal_unsafe_paste_dialog_new (_tmp12_, _tmp13_, _tmp15_);
#line 584 "../src/Widgets/TerminalWidget.vala"
	g_object_ref_sink (_tmp16_);
#line 584 "../src/Widgets/TerminalWidget.vala"
	_tmp17_ = _tmp16_;
#line 584 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (_tmp15_);
#line 584 "../src/Widgets/TerminalWidget.vala"
	_data3_->dialog = _tmp17_;
#line 585 "../src/Widgets/TerminalWidget.vala"
	_tmp18_ = _data3_->dialog;
#line 585 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_data ((GtkDialog*) _tmp18_, "response", (GCallback) ___lambda33__gtk_dialog_response, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 592 "../src/Widgets/TerminalWidget.vala"
	_tmp19_ = _data3_->dialog;
#line 592 "../src/Widgets/TerminalWidget.vala"
	gtk_window_present ((GtkWindow*) _tmp19_);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (warn_text);
#line 561 "../src/Widgets/TerminalWidget.vala"
	block3_data_unref (_data3_);
#line 561 "../src/Widgets/TerminalWidget.vala"
	_data3_ = NULL;
#line 1970 "TerminalWidget.c"
}

static GdkRGBA*
_vala_array_dup1 (GdkRGBA* self,
                  gssize length)
{
#line 615 "../src/Widgets/TerminalWidget.vala"
	if (length > 0) {
#line 615 "../src/Widgets/TerminalWidget.vala"
		return _vala_memdup2 (self, length * sizeof (GdkRGBA));
#line 1981 "TerminalWidget.c"
	}
#line 615 "../src/Widgets/TerminalWidget.vala"
	return NULL;
#line 1985 "TerminalWidget.c"
}

static void
terminal_terminal_widget_update_theme (TerminalTerminalWidget* self)
{
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GdkRGBA* theme_palette = NULL;
	GdkRGBA* _tmp2_;
	gint theme_palette_length1;
	gint _theme_palette_size_;
	GSettings* _tmp3_;
	GdkRGBA background = {0};
	GdkRGBA* _tmp19_;
	gint _tmp19__length1;
	GdkRGBA _tmp20_;
	GdkRGBA foreground = {0};
	GdkRGBA* _tmp21_;
	gint _tmp21__length1;
	GdkRGBA _tmp22_;
	GdkRGBA cursor = {0};
	GdkRGBA* _tmp23_;
	gint _tmp23__length1;
	GdkRGBA _tmp24_;
	GdkRGBA* palette = NULL;
	GdkRGBA* _tmp25_;
	gint _tmp25__length1;
	GdkRGBA* _tmp26_;
	gint _tmp26__length1;
	gint palette_length1;
	gint _palette_size_;
	GdkRGBA _tmp27_;
	GdkRGBA _tmp28_;
	GdkRGBA _tmp29_;
#line 595 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 596 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 596 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 596 "../src/Widgets/TerminalWidget.vala"
	gtk_settings = _tmp1_;
#line 597 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = g_new0 (GdkRGBA, TERMINAL_THEMES_PALETTE_SIZE);
#line 597 "../src/Widgets/TerminalWidget.vala"
	theme_palette = _tmp2_;
#line 597 "../src/Widgets/TerminalWidget.vala"
	theme_palette_length1 = TERMINAL_THEMES_PALETTE_SIZE;
#line 597 "../src/Widgets/TerminalWidget.vala"
	_theme_palette_size_ = theme_palette_length1;
#line 598 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = terminal_application_settings;
#line 598 "../src/Widgets/TerminalWidget.vala"
	if (g_settings_get_boolean (_tmp3_, "follow-system-style")) {
#line 2041 "TerminalWidget.c"
		gboolean system_prefers_dark = FALSE;
		GraniteSettings* _tmp4_;
		GraniteSettingsColorScheme _tmp5_;
		GraniteSettingsColorScheme _tmp6_;
		GtkSettings* _tmp7_;
#line 599 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = granite_settings_get_default ();
#line 599 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = granite_settings_get_prefers_color_scheme (_tmp4_);
#line 599 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 599 "../src/Widgets/TerminalWidget.vala"
		system_prefers_dark = _tmp6_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK;
#line 600 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = gtk_settings;
#line 600 "../src/Widgets/TerminalWidget.vala"
		g_object_set (_tmp7_, "gtk-application-prefer-dark-theme", system_prefers_dark, NULL);
#line 602 "../src/Widgets/TerminalWidget.vala"
		if (system_prefers_dark) {
#line 2061 "TerminalWidget.c"
			gint _tmp8_ = 0;
			GdkRGBA* _tmp9_;
#line 603 "../src/Widgets/TerminalWidget.vala"
			_tmp9_ = terminal_themes_get_rgba_palette (TERMINAL_THEMES_DARK, &_tmp8_);
#line 603 "../src/Widgets/TerminalWidget.vala"
			theme_palette = (g_free (theme_palette), NULL);
#line 603 "../src/Widgets/TerminalWidget.vala"
			theme_palette = _tmp9_;
#line 603 "../src/Widgets/TerminalWidget.vala"
			theme_palette_length1 = _tmp8_;
#line 603 "../src/Widgets/TerminalWidget.vala"
			_theme_palette_size_ = theme_palette_length1;
#line 2074 "TerminalWidget.c"
		} else {
			gint _tmp10_ = 0;
			GdkRGBA* _tmp11_;
#line 605 "../src/Widgets/TerminalWidget.vala"
			_tmp11_ = terminal_themes_get_rgba_palette (TERMINAL_THEMES_LIGHT, &_tmp10_);
#line 605 "../src/Widgets/TerminalWidget.vala"
			theme_palette = (g_free (theme_palette), NULL);
#line 605 "../src/Widgets/TerminalWidget.vala"
			theme_palette = _tmp11_;
#line 605 "../src/Widgets/TerminalWidget.vala"
			theme_palette_length1 = _tmp10_;
#line 605 "../src/Widgets/TerminalWidget.vala"
			_theme_palette_size_ = theme_palette_length1;
#line 2088 "TerminalWidget.c"
		}
	} else {
		GtkSettings* _tmp12_;
		GSettings* _tmp13_;
		GSettings* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gint _tmp17_ = 0;
		GdkRGBA* _tmp18_;
#line 608 "../src/Widgets/TerminalWidget.vala"
		_tmp12_ = gtk_settings;
#line 608 "../src/Widgets/TerminalWidget.vala"
		_tmp13_ = terminal_application_settings;
#line 608 "../src/Widgets/TerminalWidget.vala"
		g_object_set (_tmp12_, "gtk-application-prefer-dark-theme", g_settings_get_boolean (_tmp13_, "prefer-dark-style"), NULL);
#line 609 "../src/Widgets/TerminalWidget.vala"
		_tmp14_ = terminal_application_settings;
#line 609 "../src/Widgets/TerminalWidget.vala"
		_tmp15_ = g_settings_get_string (_tmp14_, "theme");
#line 609 "../src/Widgets/TerminalWidget.vala"
		_tmp16_ = _tmp15_;
#line 609 "../src/Widgets/TerminalWidget.vala"
		_tmp18_ = terminal_themes_get_rgba_palette (_tmp16_, &_tmp17_);
#line 609 "../src/Widgets/TerminalWidget.vala"
		theme_palette = (g_free (theme_palette), NULL);
#line 609 "../src/Widgets/TerminalWidget.vala"
		theme_palette = _tmp18_;
#line 609 "../src/Widgets/TerminalWidget.vala"
		theme_palette_length1 = _tmp17_;
#line 609 "../src/Widgets/TerminalWidget.vala"
		_theme_palette_size_ = theme_palette_length1;
#line 609 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp16_);
#line 2122 "TerminalWidget.c"
	}
#line 612 "../src/Widgets/TerminalWidget.vala"
	_tmp19_ = theme_palette;
#line 612 "../src/Widgets/TerminalWidget.vala"
	_tmp19__length1 = theme_palette_length1;
#line 612 "../src/Widgets/TerminalWidget.vala"
	_tmp20_ = _tmp19_[TERMINAL_THEMES_PALETTE_SIZE - 3];
#line 612 "../src/Widgets/TerminalWidget.vala"
	background = _tmp20_;
#line 613 "../src/Widgets/TerminalWidget.vala"
	_tmp21_ = theme_palette;
#line 613 "../src/Widgets/TerminalWidget.vala"
	_tmp21__length1 = theme_palette_length1;
#line 613 "../src/Widgets/TerminalWidget.vala"
	_tmp22_ = _tmp21_[TERMINAL_THEMES_PALETTE_SIZE - 2];
#line 613 "../src/Widgets/TerminalWidget.vala"
	foreground = _tmp22_;
#line 614 "../src/Widgets/TerminalWidget.vala"
	_tmp23_ = theme_palette;
#line 614 "../src/Widgets/TerminalWidget.vala"
	_tmp23__length1 = theme_palette_length1;
#line 614 "../src/Widgets/TerminalWidget.vala"
	_tmp24_ = _tmp23_[TERMINAL_THEMES_PALETTE_SIZE - 1];
#line 614 "../src/Widgets/TerminalWidget.vala"
	cursor = _tmp24_;
#line 615 "../src/Widgets/TerminalWidget.vala"
	_tmp25_ = theme_palette;
#line 615 "../src/Widgets/TerminalWidget.vala"
	_tmp25__length1 = theme_palette_length1;
#line 615 "../src/Widgets/TerminalWidget.vala"
	_tmp26_ = (_tmp25_ != NULL) ? _vala_array_dup1 (_tmp25_ + 0, 16 - 0) : _tmp25_;
#line 615 "../src/Widgets/TerminalWidget.vala"
	_tmp26__length1 = 16 - 0;
#line 615 "../src/Widgets/TerminalWidget.vala"
	palette = _tmp26_;
#line 615 "../src/Widgets/TerminalWidget.vala"
	palette_length1 = _tmp26__length1;
#line 615 "../src/Widgets/TerminalWidget.vala"
	_palette_size_ = palette_length1;
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp27_ = foreground;
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp28_ = background;
#line 617 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_colors ((VteTerminal*) self, &_tmp27_, &_tmp28_, palette, (gsize) palette_length1);
#line 618 "../src/Widgets/TerminalWidget.vala"
	_tmp29_ = cursor;
#line 618 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_color_cursor ((VteTerminal*) self, &_tmp29_);
#line 595 "../src/Widgets/TerminalWidget.vala"
	palette = (g_free (palette), NULL);
#line 595 "../src/Widgets/TerminalWidget.vala"
	theme_palette = (g_free (theme_palette), NULL);
#line 595 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (gtk_settings);
#line 2178 "TerminalWidget.c"
}

static void
terminal_terminal_widget_update_audible_bell (TerminalTerminalWidget* self)
{
	GSettings* _tmp0_;
#line 621 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 622 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_application_settings;
#line 622 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_audible_bell ((VteTerminal*) self, g_settings_get_boolean (_tmp0_, "audible-bell"));
#line 2191 "TerminalWidget.c"
}

static void
terminal_terminal_widget_update_cursor_shape (TerminalTerminalWidget* self)
{
	GSettings* _tmp0_;
#line 625 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 626 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_application_settings;
#line 626 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_cursor_shape ((VteTerminal*) self, (VteCursorShape) g_settings_get_enum (_tmp0_, "cursor-shape"));
#line 2204 "TerminalWidget.c"
}

static void
terminal_terminal_widget_on_child_exited (TerminalTerminalWidget* self)
{
#line 629 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 630 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_child_has_exited (self, TRUE);
#line 631 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 2216 "TerminalWidget.c"
}

void
terminal_terminal_widget_kill_fg (TerminalTerminalWidget* self)
{
	gint fg_pid = 0;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
#line 634 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 636 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = terminal_terminal_widget_try_get_foreground_pid (self, &_tmp0_);
#line 636 "../src/Widgets/TerminalWidget.vala"
	fg_pid = _tmp0_;
#line 636 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_) {
#line 637 "../src/Widgets/TerminalWidget.vala"
		kill ((pid_t) fg_pid, (gint) SIGKILL);
#line 2235 "TerminalWidget.c"
	}
}

void
terminal_terminal_widget_term_ps (TerminalTerminalWidget* self)
{
	gint pid_fd = 0;
	struct pollfd pid_pfd[1] = {0};
	struct pollfd _tmp0_ = {0};
#line 640 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 641 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_killed (self, TRUE);
#line 644 "../src/Widgets/TerminalWidget.vala"
	pid_fd = syscall (TERMINAL_TERMINAL_WIDGET_SYS_PIDFD_OPEN, self->priv->child_pid, 0, NULL);
#line 649 "../src/Widgets/TerminalWidget.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGHUP);
#line 650 "../src/Widgets/TerminalWidget.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGTERM);
#line 653 "../src/Widgets/TerminalWidget.vala"
	if (pid_fd == -1) {
#line 656 "../src/Widgets/TerminalWidget.vala"
		waitpid ((pid_t) self->priv->child_pid, NULL, 0);
#line 662 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2261 "TerminalWidget.c"
	}
#line 666 "../src/Widgets/TerminalWidget.vala"
	memset (&_tmp0_, 0, sizeof (struct pollfd));
#line 666 "../src/Widgets/TerminalWidget.vala"
	_tmp0_.fd = pid_fd;
#line 666 "../src/Widgets/TerminalWidget.vala"
	_tmp0_.events = POLLIN;
#line 666 "../src/Widgets/TerminalWidget.vala"
	pid_pfd[0] = _tmp0_;
#line 672 "../src/Widgets/TerminalWidget.vala"
	while (TRUE) {
#line 672 "../src/Widgets/TerminalWidget.vala"
		if (!(poll (pid_pfd, (gint) 1, -1) != 1)) {
#line 672 "../src/Widgets/TerminalWidget.vala"
			break;
#line 2277 "TerminalWidget.c"
		}
	}
#line 674 "../src/Widgets/TerminalWidget.vala"
	close (pid_fd);
#line 2282 "TerminalWidget.c"
}

void
terminal_terminal_widget_active_shell (TerminalTerminalWidget* self,
                                       const gchar* dir)
{
	gchar* shell = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar** envv = NULL;
	gint envv_length1;
	gint _envv_size_;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	GError* _inner_error0_ = NULL;
#line 677 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 677 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (dir != NULL);
#line 678 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_application_settings;
#line 678 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "shell");
#line 678 "../src/Widgets/TerminalWidget.vala"
	shell = _tmp1_;
#line 679 "../src/Widgets/TerminalWidget.vala"
	envv = NULL;
#line 679 "../src/Widgets/TerminalWidget.vala"
	envv_length1 = 0;
#line 679 "../src/Widgets/TerminalWidget.vala"
	_envv_size_ = envv_length1;
#line 681 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = shell;
#line 681 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 2323 "TerminalWidget.c"
		gchar* _tmp3_;
#line 682 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = vte_get_user_shell ();
#line 682 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (shell);
#line 682 "../src/Widgets/TerminalWidget.vala"
		shell = _tmp3_;
#line 2331 "TerminalWidget.c"
	}
#line 685 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = shell;
#line 685 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (_tmp4_, "") == 0) {
#line 686 "../src/Widgets/TerminalWidget.vala"
		g_critical ("TerminalWidget.vala:686: No user shell available");
#line 687 "../src/Widgets/TerminalWidget.vala"
		envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 687 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (shell);
#line 687 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2345 "TerminalWidget.c"
	}
#line 690 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (dir, "") == 0) {
#line 691 "../src/Widgets/TerminalWidget.vala"
		g_debug ("TerminalWidget.vala:691: Using fallback directory");
#line 692 "../src/Widgets/TerminalWidget.vala"
		dir = "/";
#line 2353 "TerminalWidget.c"
	}
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = self->terminal_id;
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = g_strconcat ("PANTHEON_TERMINAL_ID=", _tmp5_, NULL);
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = g_getenv ("PROMPT_COMMAND");
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp8_ = g_strconcat ("PROMPT_COMMAND=" TERMINAL_TERMINAL_WIDGET_SEND_PROCESS_FINISHED_BASH, _tmp7_, NULL);
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp9_ = g_new0 (gchar*, 2 + 1);
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp9_[0] = _tmp6_;
#line 695 "../src/Widgets/TerminalWidget.vala"
	_tmp9_[1] = _tmp8_;
#line 695 "../src/Widgets/TerminalWidget.vala"
	envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 695 "../src/Widgets/TerminalWidget.vala"
	envv = _tmp9_;
#line 695 "../src/Widgets/TerminalWidget.vala"
	envv_length1 = 2;
#line 695 "../src/Widgets/TerminalWidget.vala"
	_envv_size_ = envv_length1;
#line 2377 "TerminalWidget.c"
	{
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		gchar** _tmp14_;
		gint _tmp14__length1;
		GPid _tmp15_ = 0;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp10_ = shell;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp12_[0] = _tmp11_;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp13_ = _tmp12_;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp13__length1 = 1;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp14_ = envv;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp14__length1 = envv_length1;
#line 710 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_spawn_sync ((VteTerminal*) self, VTE_PTY_DEFAULT, dir, _tmp13_, _tmp14_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp15_, NULL, &_inner_error0_);
#line 710 "../src/Widgets/TerminalWidget.vala"
		self->priv->child_pid = _tmp15_;
#line 710 "../src/Widgets/TerminalWidget.vala"
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 710 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2411 "TerminalWidget.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 709 "../src/Widgets/TerminalWidget.vala"
		e = _inner_error0_;
#line 709 "../src/Widgets/TerminalWidget.vala"
		_inner_error0_ = NULL;
#line 713 "../src/Widgets/TerminalWidget.vala"
		_tmp16_ = e;
#line 713 "../src/Widgets/TerminalWidget.vala"
		_tmp17_ = _tmp16_->message;
#line 713 "../src/Widgets/TerminalWidget.vala"
		g_warning ("TerminalWidget.vala:713: %s", _tmp17_);
#line 709 "../src/Widgets/TerminalWidget.vala"
		_g_error_free0 (e);
#line 2433 "TerminalWidget.c"
	}
	__finally0:
#line 709 "../src/Widgets/TerminalWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 709 "../src/Widgets/TerminalWidget.vala"
		envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 709 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (shell);
#line 709 "../src/Widgets/TerminalWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 709 "../src/Widgets/TerminalWidget.vala"
		g_clear_error (&_inner_error0_);
#line 709 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2448 "TerminalWidget.c"
	}
#line 716 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_check_cwd_changed (self);
#line 677 "../src/Widgets/TerminalWidget.vala"
	envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 677 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (shell);
#line 2456 "TerminalWidget.c"
}

void
terminal_terminal_widget_run_program (TerminalTerminalWidget* self,
                                      const gchar* _program_string,
                                      const gchar* working_directory)
{
	GError* _inner_error0_ = NULL;
#line 719 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 719 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (_program_string != NULL);
#line 2469 "TerminalWidget.c"
	{
		gchar** program_with_args = NULL;
		gint program_with_args_length1;
		gint _program_with_args_size_;
		const gchar* _tmp0_;
		gchar** _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gchar** _tmp3_;
		gint _tmp3__length1;
		GPid _tmp4_ = 0;
#line 721 "../src/Widgets/TerminalWidget.vala"
		program_with_args = NULL;
#line 721 "../src/Widgets/TerminalWidget.vala"
		program_with_args_length1 = 0;
#line 721 "../src/Widgets/TerminalWidget.vala"
		_program_with_args_size_ = program_with_args_length1;
#line 722 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_program_string (self, _program_string);
#line 723 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = self->priv->_program_string;
#line 723 "../src/Widgets/TerminalWidget.vala"
		g_shell_parse_argv (_tmp0_, &_tmp2_, &_tmp1_, &_inner_error0_);
#line 723 "../src/Widgets/TerminalWidget.vala"
		program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 723 "../src/Widgets/TerminalWidget.vala"
		program_with_args = _tmp1_;
#line 723 "../src/Widgets/TerminalWidget.vala"
		program_with_args_length1 = _tmp2_;
#line 723 "../src/Widgets/TerminalWidget.vala"
		_program_with_args_size_ = program_with_args_length1;
#line 723 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 723 "../src/Widgets/TerminalWidget.vala"
			program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 2504 "TerminalWidget.c"
			goto __catch0_g_error;
		}
#line 725 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = program_with_args;
#line 725 "../src/Widgets/TerminalWidget.vala"
		_tmp3__length1 = program_with_args_length1;
#line 725 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_spawn_sync ((VteTerminal*) self, VTE_PTY_DEFAULT, working_directory, _tmp3_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, NULL, &_inner_error0_);
#line 725 "../src/Widgets/TerminalWidget.vala"
		self->priv->child_pid = _tmp4_;
#line 725 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 725 "../src/Widgets/TerminalWidget.vala"
			program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 2519 "TerminalWidget.c"
			goto __catch0_g_error;
		}
#line 720 "../src/Widgets/TerminalWidget.vala"
		program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 2524 "TerminalWidget.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		guint8* _tmp11_;
		gint _tmp11__length1;
		gint _tmp12_ = 0;
		guint8* _tmp13_;
		gint _tmp13__length1;
#line 720 "../src/Widgets/TerminalWidget.vala"
		e = _inner_error0_;
#line 720 "../src/Widgets/TerminalWidget.vala"
		_inner_error0_ = NULL;
#line 728 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = e;
#line 728 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_->message;
#line 728 "../src/Widgets/TerminalWidget.vala"
		g_warning ("TerminalWidget.vala:728: %s", _tmp6_);
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = e;
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp8_ = _tmp7_->message;
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp9_ = g_strconcat (_tmp8_, "\r\n\r\n", NULL);
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp10_ = _tmp9_;
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp11_ = string_get_data (_tmp10_, &_tmp12_);
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp11__length1 = _tmp12_;
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp13_ = _tmp11_;
#line 729 "../src/Widgets/TerminalWidget.vala"
		_tmp13__length1 = _tmp11__length1;
#line 729 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_feed ((VteTerminal*) self, _tmp13_, (gssize) _tmp13__length1);
#line 729 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp10_);
#line 730 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_active_shell (self, working_directory);
#line 720 "../src/Widgets/TerminalWidget.vala"
		_g_error_free0 (e);
#line 2575 "TerminalWidget.c"
	}
	__finally0:
#line 720 "../src/Widgets/TerminalWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 720 "../src/Widgets/TerminalWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 720 "../src/Widgets/TerminalWidget.vala"
		g_clear_error (&_inner_error0_);
#line 720 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2586 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_try_get_foreground_pid (TerminalTerminalWidget* self,
                                                 gint* pid)
{
	gint _vala_pid = 0;
	gboolean _tmp0_;
	gint pty = 0;
	VtePty* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint fgpid = 0;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 734 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 735 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_child_has_exited;
#line 735 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 736 "../src/Widgets/TerminalWidget.vala"
		_vala_pid = -1;
#line 737 "../src/Widgets/TerminalWidget.vala"
		result = FALSE;
#line 737 "../src/Widgets/TerminalWidget.vala"
		if (pid) {
#line 737 "../src/Widgets/TerminalWidget.vala"
			*pid = _vala_pid;
#line 2617 "TerminalWidget.c"
		}
#line 737 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 2621 "TerminalWidget.c"
	}
#line 740 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = vte_terminal_get_pty ((VteTerminal*) self);
#line 740 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = vte_pty_get_fd (_tmp1_);
#line 740 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _tmp2_;
#line 740 "../src/Widgets/TerminalWidget.vala"
	pty = _tmp3_;
#line 741 "../src/Widgets/TerminalWidget.vala"
	fgpid = (gint) tcgetpgrp (pty);
#line 743 "../src/Widgets/TerminalWidget.vala"
	if (fgpid != ((gint) self->priv->child_pid)) {
#line 743 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = fgpid != -1;
#line 2637 "TerminalWidget.c"
	} else {
#line 743 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = FALSE;
#line 2641 "TerminalWidget.c"
	}
#line 743 "../src/Widgets/TerminalWidget.vala"
	if (_tmp4_) {
#line 744 "../src/Widgets/TerminalWidget.vala"
		_vala_pid = (gint) fgpid;
#line 745 "../src/Widgets/TerminalWidget.vala"
		result = TRUE;
#line 745 "../src/Widgets/TerminalWidget.vala"
		if (pid) {
#line 745 "../src/Widgets/TerminalWidget.vala"
			*pid = _vala_pid;
#line 2653 "TerminalWidget.c"
		}
#line 745 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 2657 "TerminalWidget.c"
	} else {
#line 747 "../src/Widgets/TerminalWidget.vala"
		_vala_pid = -1;
#line 748 "../src/Widgets/TerminalWidget.vala"
		result = FALSE;
#line 748 "../src/Widgets/TerminalWidget.vala"
		if (pid) {
#line 748 "../src/Widgets/TerminalWidget.vala"
			*pid = _vala_pid;
#line 2667 "TerminalWidget.c"
		}
#line 748 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 2671 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_has_foreground_process (TerminalTerminalWidget* self)
{
	gboolean result;
#line 752 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 753 "../src/Widgets/TerminalWidget.vala"
	result = terminal_terminal_widget_try_get_foreground_pid (self, NULL);
#line 753 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 2685 "TerminalWidget.c"
}

gint
terminal_terminal_widget_calculate_width (TerminalTerminalWidget* self,
                                          gint column_count)
{
	gint width = 0;
	gint result;
#line 756 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 757 "../src/Widgets/TerminalWidget.vala"
	width = ((gint) vte_terminal_get_char_width ((VteTerminal*) self)) * column_count;
#line 758 "../src/Widgets/TerminalWidget.vala"
	result = width;
#line 758 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 2702 "TerminalWidget.c"
}

gint
terminal_terminal_widget_calculate_height (TerminalTerminalWidget* self,
                                           gint row_count)
{
	gint height = 0;
	gint result;
#line 761 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 762 "../src/Widgets/TerminalWidget.vala"
	height = ((gint) vte_terminal_get_char_height ((VteTerminal*) self)) * row_count;
#line 763 "../src/Widgets/TerminalWidget.vala"
	result = height;
#line 763 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 2719 "TerminalWidget.c"
}

static void
terminal_terminal_widget_clickable (TerminalTerminalWidget* self,
                                    gchar** str,
                                    gint str_length1)
{
	GError* _inner_error0_ = NULL;
#line 766 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 2730 "TerminalWidget.c"
	{
		gchar** exp_collection = NULL;
		gint exp_collection_length1 = 0;
		gint _exp_collection_size_ = 0;
		gint exp_it = 0;
#line 767 "../src/Widgets/TerminalWidget.vala"
		exp_collection = str;
#line 767 "../src/Widgets/TerminalWidget.vala"
		exp_collection_length1 = str_length1;
#line 767 "../src/Widgets/TerminalWidget.vala"
		for (exp_it = 0; exp_it < exp_collection_length1; exp_it = exp_it + 1) {
#line 2742 "TerminalWidget.c"
			const gchar* exp = NULL;
#line 767 "../src/Widgets/TerminalWidget.vala"
			exp = exp_collection[exp_it];
#line 2746 "TerminalWidget.c"
			{
				{
					VteRegex* regex = NULL;
					const gchar* _tmp0_;
					VteRegex* _tmp1_;
					gint id = 0;
					VteRegex* _tmp2_;
#line 769 "../src/Widgets/TerminalWidget.vala"
					_tmp0_ = exp;
#line 769 "../src/Widgets/TerminalWidget.vala"
					_tmp1_ = vte_regex_new_for_match (_tmp0_, (gssize) -1, (guint32) PCRE2_MULTILINE, &_inner_error0_);
#line 769 "../src/Widgets/TerminalWidget.vala"
					regex = _tmp1_;
#line 769 "../src/Widgets/TerminalWidget.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2762 "TerminalWidget.c"
						goto __catch0_g_error;
					}
#line 770 "../src/Widgets/TerminalWidget.vala"
					_tmp2_ = regex;
#line 770 "../src/Widgets/TerminalWidget.vala"
					id = vte_terminal_match_add_regex ((VteTerminal*) self, _tmp2_, (guint32) 0);
#line 771 "../src/Widgets/TerminalWidget.vala"
					vte_terminal_match_set_cursor_name ((VteTerminal*) self, id, "pointer");
#line 768 "../src/Widgets/TerminalWidget.vala"
					_vte_regex_unref0 (regex);
#line 2773 "TerminalWidget.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* _error_ = NULL;
					GError* _tmp3_;
					const gchar* _tmp4_;
#line 768 "../src/Widgets/TerminalWidget.vala"
					_error_ = _inner_error0_;
#line 768 "../src/Widgets/TerminalWidget.vala"
					_inner_error0_ = NULL;
#line 773 "../src/Widgets/TerminalWidget.vala"
					_tmp3_ = _error_;
#line 773 "../src/Widgets/TerminalWidget.vala"
					_tmp4_ = _tmp3_->message;
#line 773 "../src/Widgets/TerminalWidget.vala"
					g_warning ("TerminalWidget.vala:773: %s", _tmp4_);
#line 768 "../src/Widgets/TerminalWidget.vala"
					_g_error_free0 (_error_);
#line 2793 "TerminalWidget.c"
				}
				__finally0:
#line 768 "../src/Widgets/TerminalWidget.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "../src/Widgets/TerminalWidget.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 768 "../src/Widgets/TerminalWidget.vala"
					g_clear_error (&_inner_error0_);
#line 768 "../src/Widgets/TerminalWidget.vala"
					return;
#line 2804 "TerminalWidget.c"
				}
			}
		}
	}
}

static gchar*
terminal_terminal_widget_get_link (TerminalTerminalWidget* self,
                                   GdkEvent* event)
{
	gchar* _tmp0_;
	gchar* result;
#line 778 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 778 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (event != NULL, NULL);
#line 779 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_match_check_event ((VteTerminal*) self, event, NULL);
#line 779 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 779 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 2827 "TerminalWidget.c"
}

gchar*
terminal_terminal_widget_get_shell_location (TerminalTerminalWidget* self)
{
	gint pid = 0;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 782 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 783 "../src/Widgets/TerminalWidget.vala"
	pid = (gint) ((GPid) self->priv->child_pid);
#line 2840 "TerminalWidget.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = g_strdup_printf ("/proc/%d/cwd", pid);
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = _tmp1_;
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = g_file_read_link (_tmp2_, &_inner_error0_);
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = _tmp3_;
#line 786 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp2_);
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = _tmp4_;
#line 786 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 786 "../src/Widgets/TerminalWidget.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2864 "TerminalWidget.c"
				goto __catch0_g_file_error;
			}
#line 786 "../src/Widgets/TerminalWidget.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 786 "../src/Widgets/TerminalWidget.vala"
			g_clear_error (&_inner_error0_);
#line 786 "../src/Widgets/TerminalWidget.vala"
			return NULL;
#line 2873 "TerminalWidget.c"
		}
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = _tmp0_;
#line 786 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = NULL;
#line 786 "../src/Widgets/TerminalWidget.vala"
		result = _tmp5_;
#line 786 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp0_);
#line 786 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 2885 "TerminalWidget.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		gchar* _tmp6_;
#line 785 "../src/Widgets/TerminalWidget.vala"
		g_clear_error (&_inner_error0_);
#line 790 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = g_strdup ("");
#line 790 "../src/Widgets/TerminalWidget.vala"
		result = _tmp6_;
#line 790 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 2899 "TerminalWidget.c"
	}
	__finally0:
#line 785 "../src/Widgets/TerminalWidget.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 785 "../src/Widgets/TerminalWidget.vala"
	g_clear_error (&_inner_error0_);
#line 785 "../src/Widgets/TerminalWidget.vala"
	return NULL;
#line 2908 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_increase_font_size (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 794 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 795 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 795 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 795 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, _tmp1_ + 0.1);
#line 2925 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_decrease_font_size (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 798 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 799 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 799 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 799 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, _tmp1_ - 0.1);
#line 2942 "TerminalWidget.c"
}

void
terminal_terminal_widget_default_font_size (TerminalTerminalWidget* self)
{
#line 802 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 803 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, 1.0);
#line 2952 "TerminalWidget.c"
}

gboolean
terminal_terminal_widget_is_init_complete (TerminalTerminalWidget* self)
{
	gboolean result;
#line 806 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 807 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->init_complete;
#line 807 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 2965 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_init_complete (TerminalTerminalWidget* self)
{
#line 810 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 811 "../src/Widgets/TerminalWidget.vala"
	self->priv->init_complete = TRUE;
#line 2975 "TerminalWidget.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 2989 "TerminalWidget.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 2993 "TerminalWidget.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 2999 "TerminalWidget.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 3004 "TerminalWidget.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 3010 "TerminalWidget.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 3014 "TerminalWidget.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 3018 "TerminalWidget.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 3022 "TerminalWidget.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3026 "TerminalWidget.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3030 "TerminalWidget.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 3045 "TerminalWidget.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 3054 "TerminalWidget.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 3061 "TerminalWidget.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 3067 "TerminalWidget.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 3075 "TerminalWidget.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 3079 "TerminalWidget.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 3085 "TerminalWidget.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 3090 "TerminalWidget.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 3096 "TerminalWidget.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 3100 "TerminalWidget.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 3104 "TerminalWidget.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 3110 "TerminalWidget.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 3116 "TerminalWidget.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 3128 "TerminalWidget.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 3132 "TerminalWidget.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 3136 "TerminalWidget.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 3141 "TerminalWidget.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 3149 "TerminalWidget.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 3167 "TerminalWidget.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 3173 "TerminalWidget.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 3177 "TerminalWidget.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 3185 "TerminalWidget.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 3194 "TerminalWidget.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 3203 "TerminalWidget.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 3209 "TerminalWidget.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 3217 "TerminalWidget.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 3229 "TerminalWidget.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 3235 "TerminalWidget.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 3239 "TerminalWidget.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 3247 "TerminalWidget.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 3258 "TerminalWidget.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 3267 "TerminalWidget.c"
	}
}

void
terminal_terminal_widget_drag_received (TerminalTerminalWidget* self,
                                        GdkDragContext* context,
                                        gint x,
                                        gint y,
                                        GtkSelectionData* selection_data,
                                        guint target_type,
                                        guint time_)
{
	GError* _inner_error0_ = NULL;
#line 814 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 814 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (context != NULL);
#line 814 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (selection_data != NULL);
#line 816 "../src/Widgets/TerminalWidget.vala"
	switch (target_type) {
#line 816 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST:
#line 3291 "TerminalWidget.c"
		{
			gchar** uris = NULL;
			gchar** _tmp0_;
			gchar** _tmp1_;
			gint uris_length1;
			gint _uris_size_;
			gchar* path = NULL;
			GFile* file = NULL;
			gchar* uris_s = NULL;
			gchar** _tmp31_;
			gint _tmp31__length1;
			gchar* _tmp32_;
			const gchar* _tmp33_;
			guint8* _tmp34_;
			gint _tmp34__length1;
			gint _tmp35_ = 0;
			guint8* _tmp36_;
			gint _tmp36__length1;
#line 818 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = _tmp0_ = gtk_selection_data_get_uris (selection_data);
#line 818 "../src/Widgets/TerminalWidget.vala"
			uris = _tmp1_;
#line 818 "../src/Widgets/TerminalWidget.vala"
			uris_length1 = _vala_array_length (_tmp0_);
#line 818 "../src/Widgets/TerminalWidget.vala"
			_uris_size_ = uris_length1;
#line 3318 "TerminalWidget.c"
			{
				gint i = 0;
#line 821 "../src/Widgets/TerminalWidget.vala"
				i = 0;
#line 3323 "TerminalWidget.c"
				{
					gboolean _tmp2_ = FALSE;
#line 821 "../src/Widgets/TerminalWidget.vala"
					_tmp2_ = TRUE;
#line 821 "../src/Widgets/TerminalWidget.vala"
					while (TRUE) {
#line 3330 "TerminalWidget.c"
						gchar** _tmp4_;
						gint _tmp4__length1;
						gchar* unquoted_uri = NULL;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						gchar* _tmp19_;
						GFile* _tmp20_;
						GFile* _tmp21_;
						gchar* _tmp22_;
						const gchar* _tmp23_;
#line 821 "../src/Widgets/TerminalWidget.vala"
						if (!_tmp2_) {
#line 3343 "TerminalWidget.c"
							gint _tmp3_;
#line 821 "../src/Widgets/TerminalWidget.vala"
							_tmp3_ = i;
#line 821 "../src/Widgets/TerminalWidget.vala"
							i = _tmp3_ + 1;
#line 3349 "TerminalWidget.c"
						}
#line 821 "../src/Widgets/TerminalWidget.vala"
						_tmp2_ = FALSE;
#line 821 "../src/Widgets/TerminalWidget.vala"
						_tmp4_ = uris;
#line 821 "../src/Widgets/TerminalWidget.vala"
						_tmp4__length1 = uris_length1;
#line 821 "../src/Widgets/TerminalWidget.vala"
						if (!(i < _tmp4__length1)) {
#line 821 "../src/Widgets/TerminalWidget.vala"
							break;
#line 3361 "TerminalWidget.c"
						}
						{
							gchar* _tmp5_ = NULL;
							gchar** _tmp6_;
							gint _tmp6__length1;
							const gchar* _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp6_ = uris;
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp6__length1 = uris_length1;
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp7_ = _tmp6_[i];
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp8_ = g_shell_unquote (_tmp7_, &_inner_error0_);
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp5_ = _tmp8_;
#line 826 "../src/Widgets/TerminalWidget.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3382 "TerminalWidget.c"
								goto __catch0_g_error;
							}
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp9_ = _tmp5_;
#line 826 "../src/Widgets/TerminalWidget.vala"
							_tmp5_ = NULL;
#line 826 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (unquoted_uri);
#line 826 "../src/Widgets/TerminalWidget.vala"
							unquoted_uri = _tmp9_;
#line 825 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (_tmp5_);
#line 3395 "TerminalWidget.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							gchar** _tmp10_;
							gint _tmp10__length1;
							const gchar* _tmp11_;
							GError* _tmp12_;
							const gchar* _tmp13_;
							gchar** _tmp14_;
							gint _tmp14__length1;
							const gchar* _tmp15_;
							gchar* _tmp16_;
#line 825 "../src/Widgets/TerminalWidget.vala"
							e = _inner_error0_;
#line 825 "../src/Widgets/TerminalWidget.vala"
							_inner_error0_ = NULL;
#line 828 "../src/Widgets/TerminalWidget.vala"
							_tmp10_ = uris;
#line 828 "../src/Widgets/TerminalWidget.vala"
							_tmp10__length1 = uris_length1;
#line 828 "../src/Widgets/TerminalWidget.vala"
							_tmp11_ = _tmp10_[i];
#line 828 "../src/Widgets/TerminalWidget.vala"
							_tmp12_ = e;
#line 828 "../src/Widgets/TerminalWidget.vala"
							_tmp13_ = _tmp12_->message;
#line 828 "../src/Widgets/TerminalWidget.vala"
							g_warning ("TerminalWidget.vala:828: Error unquoting %s. %s", _tmp11_, _tmp13_);
#line 829 "../src/Widgets/TerminalWidget.vala"
							_tmp14_ = uris;
#line 829 "../src/Widgets/TerminalWidget.vala"
							_tmp14__length1 = uris_length1;
#line 829 "../src/Widgets/TerminalWidget.vala"
							_tmp15_ = _tmp14_[i];
#line 829 "../src/Widgets/TerminalWidget.vala"
							_tmp16_ = g_strdup (_tmp15_);
#line 829 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (unquoted_uri);
#line 829 "../src/Widgets/TerminalWidget.vala"
							unquoted_uri = _tmp16_;
#line 825 "../src/Widgets/TerminalWidget.vala"
							_g_error_free0 (e);
#line 3440 "TerminalWidget.c"
						}
						__finally0:
#line 825 "../src/Widgets/TerminalWidget.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 825 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (unquoted_uri);
#line 825 "../src/Widgets/TerminalWidget.vala"
							_g_object_unref0 (file);
#line 825 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (path);
#line 825 "../src/Widgets/TerminalWidget.vala"
							uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 825 "../src/Widgets/TerminalWidget.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 825 "../src/Widgets/TerminalWidget.vala"
							g_clear_error (&_inner_error0_);
#line 825 "../src/Widgets/TerminalWidget.vala"
							return;
#line 3459 "TerminalWidget.c"
						}
#line 833 "../src/Widgets/TerminalWidget.vala"
						_tmp17_ = unquoted_uri;
#line 833 "../src/Widgets/TerminalWidget.vala"
						_tmp18_ = terminal_utils_sanitize_path (_tmp17_, "", FALSE);
#line 833 "../src/Widgets/TerminalWidget.vala"
						_tmp19_ = _tmp18_;
#line 833 "../src/Widgets/TerminalWidget.vala"
						_tmp20_ = g_file_new_for_uri (_tmp19_);
#line 833 "../src/Widgets/TerminalWidget.vala"
						_g_object_unref0 (file);
#line 833 "../src/Widgets/TerminalWidget.vala"
						file = _tmp20_;
#line 833 "../src/Widgets/TerminalWidget.vala"
						_g_free0 (_tmp19_);
#line 834 "../src/Widgets/TerminalWidget.vala"
						_tmp21_ = file;
#line 834 "../src/Widgets/TerminalWidget.vala"
						_tmp22_ = g_file_get_path (_tmp21_);
#line 834 "../src/Widgets/TerminalWidget.vala"
						_g_free0 (path);
#line 834 "../src/Widgets/TerminalWidget.vala"
						path = _tmp22_;
#line 835 "../src/Widgets/TerminalWidget.vala"
						_tmp23_ = path;
#line 835 "../src/Widgets/TerminalWidget.vala"
						if (_tmp23_ != NULL) {
#line 3487 "TerminalWidget.c"
							gchar** _tmp24_;
							gint _tmp24__length1;
							const gchar* _tmp25_;
							gchar* _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp24_ = uris;
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp24__length1 = uris_length1;
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp25_ = path;
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp26_ = g_shell_quote (_tmp25_);
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp27_ = _tmp26_;
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp28_ = g_strconcat (_tmp27_, " ", NULL);
#line 836 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (_tmp24_[i]);
#line 836 "../src/Widgets/TerminalWidget.vala"
							_tmp24_[i] = _tmp28_;
#line 836 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (_tmp27_);
#line 3512 "TerminalWidget.c"
						} else {
							gchar** _tmp29_;
							gint _tmp29__length1;
							gchar* _tmp30_;
#line 839 "../src/Widgets/TerminalWidget.vala"
							_tmp29_ = uris;
#line 839 "../src/Widgets/TerminalWidget.vala"
							_tmp29__length1 = uris_length1;
#line 839 "../src/Widgets/TerminalWidget.vala"
							_tmp30_ = g_strdup ("");
#line 839 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (_tmp29_[i]);
#line 839 "../src/Widgets/TerminalWidget.vala"
							_tmp29_[i] = _tmp30_;
#line 3527 "TerminalWidget.c"
						}
#line 821 "../src/Widgets/TerminalWidget.vala"
						_g_free0 (unquoted_uri);
#line 3531 "TerminalWidget.c"
					}
				}
			}
#line 843 "../src/Widgets/TerminalWidget.vala"
			_tmp31_ = uris;
#line 843 "../src/Widgets/TerminalWidget.vala"
			_tmp31__length1 = uris_length1;
#line 843 "../src/Widgets/TerminalWidget.vala"
			_tmp32_ = _vala_g_strjoinv ("", _tmp31_, (gint) _tmp31__length1);
#line 843 "../src/Widgets/TerminalWidget.vala"
			uris_s = _tmp32_;
#line 844 "../src/Widgets/TerminalWidget.vala"
			_tmp33_ = uris_s;
#line 844 "../src/Widgets/TerminalWidget.vala"
			_tmp34_ = string_get_data (_tmp33_, &_tmp35_);
#line 844 "../src/Widgets/TerminalWidget.vala"
			_tmp34__length1 = _tmp35_;
#line 844 "../src/Widgets/TerminalWidget.vala"
			_tmp36_ = _tmp34_;
#line 844 "../src/Widgets/TerminalWidget.vala"
			_tmp36__length1 = _tmp34__length1;
#line 844 "../src/Widgets/TerminalWidget.vala"
			vte_terminal_feed_child ((VteTerminal*) self, _tmp36_, (gssize) _tmp36__length1);
#line 845 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (uris_s);
#line 845 "../src/Widgets/TerminalWidget.vala"
			_g_object_unref0 (file);
#line 845 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (path);
#line 845 "../src/Widgets/TerminalWidget.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 845 "../src/Widgets/TerminalWidget.vala"
			break;
#line 3565 "TerminalWidget.c"
		}
#line 816 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING:
#line 816 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT:
#line 3571 "TerminalWidget.c"
		{
			gchar* text = NULL;
			gchar* _tmp37_;
			const gchar* _tmp38_;
#line 849 "../src/Widgets/TerminalWidget.vala"
			_tmp37_ = gtk_selection_data_get_text (selection_data);
#line 849 "../src/Widgets/TerminalWidget.vala"
			text = _tmp37_;
#line 850 "../src/Widgets/TerminalWidget.vala"
			_tmp38_ = text;
#line 850 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_validated_feed (self, _tmp38_);
#line 851 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (text);
#line 851 "../src/Widgets/TerminalWidget.vala"
			break;
#line 3588 "TerminalWidget.c"
		}
		default:
#line 816 "../src/Widgets/TerminalWidget.vala"
		break;
#line 3593 "TerminalWidget.c"
	}
}

void
terminal_terminal_widget_remember_position (TerminalTerminalWidget* self)
{
	glong col = 0L;
	glong row = 0L;
	glong _tmp0_ = 0L;
	glong _tmp1_ = 0L;
#line 855 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 857 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp0_, &_tmp1_);
#line 857 "../src/Widgets/TerminalWidget.vala"
	col = _tmp0_;
#line 857 "../src/Widgets/TerminalWidget.vala"
	row = _tmp1_;
#line 858 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_position = row;
#line 3614 "TerminalWidget.c"
}

void
terminal_terminal_widget_remember_command_start_position (TerminalTerminalWidget* self)
{
	gboolean _tmp0_ = FALSE;
	glong col = 0L;
	glong row = 0L;
	glong _tmp1_ = 0L;
	glong _tmp2_ = 0L;
#line 861 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 862 "../src/Widgets/TerminalWidget.vala"
	if (!self->last_key_was_return) {
#line 862 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = TRUE;
#line 3631 "TerminalWidget.c"
	} else {
#line 862 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = terminal_terminal_widget_has_foreground_process (self);
#line 3635 "TerminalWidget.c"
	}
#line 862 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 863 "../src/Widgets/TerminalWidget.vala"
		return;
#line 3641 "TerminalWidget.c"
	}
#line 867 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp1_, &_tmp2_);
#line 867 "../src/Widgets/TerminalWidget.vala"
	col = _tmp1_;
#line 867 "../src/Widgets/TerminalWidget.vala"
	row = _tmp2_;
#line 868 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_command_start_row = row;
#line 869 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = FALSE;
#line 870 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_resized (self, FALSE);
#line 3655 "TerminalWidget.c"
}

void
terminal_terminal_widget_remember_command_end_position (TerminalTerminalWidget* self)
{
	gboolean _tmp0_ = FALSE;
	glong col = 0L;
	glong row = 0L;
	glong _tmp1_ = 0L;
	glong _tmp2_ = 0L;
#line 873 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 874 "../src/Widgets/TerminalWidget.vala"
	if (self->last_key_was_return) {
#line 874 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = !terminal_terminal_widget_has_foreground_process (self);
#line 3672 "TerminalWidget.c"
	} else {
#line 874 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 3676 "TerminalWidget.c"
	}
#line 874 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 875 "../src/Widgets/TerminalWidget.vala"
		return;
#line 3682 "TerminalWidget.c"
	}
#line 879 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp1_, &_tmp2_);
#line 879 "../src/Widgets/TerminalWidget.vala"
	col = _tmp1_;
#line 879 "../src/Widgets/TerminalWidget.vala"
	row = _tmp2_;
#line 882 "../src/Widgets/TerminalWidget.vala"
	if ((row - self->priv->remembered_command_end_row) <= ((glong) 2)) {
#line 883 "../src/Widgets/TerminalWidget.vala"
		self->priv->remembered_command_end_row = row;
#line 3694 "TerminalWidget.c"
	}
#line 886 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 3698 "TerminalWidget.c"
}

gchar*
terminal_terminal_widget_get_last_output (TerminalTerminalWidget* self,
                                          gboolean include_command)
{
	glong output_end_col = 0L;
	glong output_end_row = 0L;
	glong start_row = 0L;
	glong _tmp0_ = 0L;
	glong _tmp1_ = 0L;
	glong command_lines = 0L;
	glong _tmp2_ = 0L;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 889 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 891 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp0_, &_tmp1_);
#line 891 "../src/Widgets/TerminalWidget.vala"
	output_end_col = _tmp0_;
#line 891 "../src/Widgets/TerminalWidget.vala"
	output_end_row = _tmp1_;
#line 893 "../src/Widgets/TerminalWidget.vala"
	command_lines = self->priv->remembered_command_end_row - self->priv->remembered_command_start_row;
#line 895 "../src/Widgets/TerminalWidget.vala"
	if (!include_command) {
#line 896 "../src/Widgets/TerminalWidget.vala"
		start_row = self->priv->remembered_command_end_row + 1;
#line 3731 "TerminalWidget.c"
	} else {
#line 898 "../src/Widgets/TerminalWidget.vala"
		start_row = self->priv->remembered_command_start_row;
#line 3735 "TerminalWidget.c"
	}
#line 901 "../src/Widgets/TerminalWidget.vala"
	if (include_command) {
#line 901 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = command_lines + 1;
#line 3741 "TerminalWidget.c"
	} else {
#line 901 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = (glong) 1;
#line 3745 "TerminalWidget.c"
	}
#line 901 "../src/Widgets/TerminalWidget.vala"
	if ((output_end_row - start_row) < _tmp2_) {
#line 3749 "TerminalWidget.c"
		gchar* _tmp3_;
#line 902 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = g_strdup ("");
#line 902 "../src/Widgets/TerminalWidget.vala"
		result = _tmp3_;
#line 902 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 3757 "TerminalWidget.c"
	}
#line 905 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 911 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = vte_terminal_get_text_range ((VteTerminal*) self, start_row, (glong) 0, output_end_row - 1, (glong) 1000, NULL, NULL, NULL);
#line 911 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = _tmp4_;
#line 911 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
#line 911 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = _tmp6_;
#line 911 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (_tmp5_);
#line 911 "../src/Widgets/TerminalWidget.vala"
	result = _tmp7_;
#line 911 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3775 "TerminalWidget.c"
}

static void
terminal_terminal_widget_scroll_to_command (TerminalTerminalWidget* self,
                                            GSimpleAction* action,
                                            GVariant* parameter)
{
	glong row = 0L;
	glong delta = 0L;
	glong _tmp0_ = 0L;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	GtkAdjustment* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	GdkWindow* _tmp7_;
#line 914 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 914 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (action != NULL);
#line 917 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, NULL, &_tmp0_);
#line 917 "../src/Widgets/TerminalWidget.vala"
	row = _tmp0_;
#line 918 "../src/Widgets/TerminalWidget.vala"
	delta = self->priv->remembered_position - row;
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) self);
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _tmp1_;
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) self);
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = _tmp3_;
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = _tmp5_;
#line 920 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = gtk_widget_get_window ((GtkWidget*) self);
#line 920 "../src/Widgets/TerminalWidget.vala"
	gtk_adjustment_set_value (_tmp4_, _tmp6_ + ((((gint) delta) + (gdk_window_get_height (_tmp7_) / vte_terminal_get_char_height ((VteTerminal*) self))) - 1));
#line 921 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (action, FALSE);
#line 3821 "TerminalWidget.c"
}

void
terminal_terminal_widget_reload (TerminalTerminalWidget* self)
{
	gchar* old_loc = NULL;
	gchar* _tmp0_;
#line 924 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 925 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_get_shell_location (self);
#line 925 "../src/Widgets/TerminalWidget.vala"
	old_loc = _tmp0_;
#line 927 "../src/Widgets/TerminalWidget.vala"
	if (terminal_terminal_widget_confirm_kill_fg_process (self, _ ("Are you sure you want to reload this tab?"), _ ("Reload Tab"))) {
#line 3837 "TerminalWidget.c"
		const gchar* _tmp1_;
#line 932 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_reset ((VteTerminal*) self, TRUE, TRUE);
#line 933 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = old_loc;
#line 933 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_active_shell (self, _tmp1_);
#line 3845 "TerminalWidget.c"
	}
#line 924 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (old_loc);
#line 3849 "TerminalWidget.c"
}

static void
terminal_terminal_widget_check_cwd_changed (TerminalTerminalWidget* self)
{
	gchar* cwd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 937 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 938 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_get_shell_location (self);
#line 938 "../src/Widgets/TerminalWidget.vala"
	cwd = _tmp0_;
#line 939 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = cwd;
#line 939 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->priv->_current_working_directory;
#line 939 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) != 0) {
#line 3871 "TerminalWidget.c"
		const gchar* _tmp3_;
		HdyTabPage* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 940 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = cwd;
#line 940 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_current_working_directory (self, _tmp3_);
#line 941 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = self->tab;
#line 941 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = self->priv->_current_working_directory;
#line 941 "../src/Widgets/TerminalWidget.vala"
		hdy_tab_page_set_tooltip (_tmp4_, _tmp5_);
#line 942 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = cwd;
#line 942 "../src/Widgets/TerminalWidget.vala"
		g_signal_emit (self, terminal_terminal_widget_signals[TERMINAL_TERMINAL_WIDGET_CWD_CHANGED_SIGNAL], 0, _tmp6_);
#line 3890 "TerminalWidget.c"
	}
#line 937 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (cwd);
#line 3894 "TerminalWidget.c"
}

const gchar*
terminal_terminal_widget_get_current_working_directory (TerminalTerminalWidget* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_current_working_directory;
#line 30 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3910 "TerminalWidget.c"
}

static void
terminal_terminal_widget_set_current_working_directory (TerminalTerminalWidget* self,
                                                        const gchar* value)
{
	gchar* old_value;
#line 30 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_current_working_directory (self);
#line 30 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3924 "TerminalWidget.c"
		gchar* _tmp0_;
#line 30 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (self->priv->_current_working_directory);
#line 30 "../src/Widgets/TerminalWidget.vala"
		self->priv->_current_working_directory = _tmp0_;
#line 30 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY]);
#line 3934 "TerminalWidget.c"
	}
}

const gchar*
terminal_terminal_widget_get_program_string (TerminalTerminalWidget* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_program_string;
#line 31 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3951 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_program_string (TerminalTerminalWidget* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 31 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_program_string (self);
#line 31 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3965 "TerminalWidget.c"
		gchar* _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (self->priv->_program_string);
#line 31 "../src/Widgets/TerminalWidget.vala"
		self->priv->_program_string = _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_PROGRAM_STRING_PROPERTY]);
#line 3975 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_get_resized (TerminalTerminalWidget* self)
{
	gboolean result;
#line 34 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->_resized;
#line 34 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3989 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_resized (TerminalTerminalWidget* self,
                                      gboolean value)
{
	gboolean old_value;
#line 34 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_resized (self);
#line 34 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 34 "../src/Widgets/TerminalWidget.vala"
		self->priv->_resized = value;
#line 34 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY]);
#line 4007 "TerminalWidget.c"
	}
}

TerminalMainWindow*
terminal_terminal_widget_get_main_window (TerminalTerminalWidget* self)
{
	TerminalMainWindow* result;
	TerminalMainWindow* _tmp0_;
#line 38 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_main_window;
#line 38 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 38 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4024 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_main_window (TerminalTerminalWidget* self,
                                          TerminalMainWindow* value)
{
	TerminalMainWindow* old_value;
#line 38 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_main_window (self);
#line 38 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 38 "../src/Widgets/TerminalWidget.vala"
		self->priv->_main_window = value;
#line 38 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_MAIN_WINDOW_PROPERTY]);
#line 4042 "TerminalWidget.c"
	}
}

static TerminalApplication*
terminal_terminal_widget_get_app (TerminalTerminalWidget* self)
{
	TerminalApplication* result;
	TerminalMainWindow* _tmp0_;
	TerminalApplication* _tmp1_;
	TerminalApplication* _tmp2_;
#line 41 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_main_window;
#line 42 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = terminal_main_window_get_app (_tmp0_);
#line 42 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/Widgets/TerminalWidget.vala"
	result = _tmp2_;
#line 42 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4065 "TerminalWidget.c"
}

const gchar*
terminal_terminal_widget_get_tab_label (TerminalTerminalWidget* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	HdyTabPage* _tmp1_;
#line 51 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->tab;
#line 52 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_ != NULL) {
#line 4080 "TerminalWidget.c"
		HdyTabPage* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 52 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = self->tab;
#line 52 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = hdy_tab_page_get_title (_tmp2_);
#line 52 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = _tmp3_;
#line 52 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = _tmp4_;
#line 4092 "TerminalWidget.c"
	} else {
#line 52 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = "";
#line 4096 "TerminalWidget.c"
	}
#line 52 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 52 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4102 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_tab_label (TerminalTerminalWidget* self,
                                        const gchar* value)
{
	gboolean _tmp0_ = FALSE;
#line 55 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Widgets/TerminalWidget.vala"
	if (value != NULL) {
#line 4114 "TerminalWidget.c"
		HdyTabPage* _tmp1_;
#line 56 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = self->tab;
#line 56 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 4120 "TerminalWidget.c"
	} else {
#line 56 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 4124 "TerminalWidget.c"
	}
#line 56 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 4128 "TerminalWidget.c"
		HdyTabPage* _tmp2_;
#line 57 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = self->tab;
#line 57 "../src/Widgets/TerminalWidget.vala"
		hdy_tab_page_set_title (_tmp2_, value);
#line 4134 "TerminalWidget.c"
	}
#line 55 "../src/Widgets/TerminalWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY]);
#line 4138 "TerminalWidget.c"
}

gboolean
terminal_terminal_widget_get_child_has_exited (TerminalTerminalWidget* self)
{
	gboolean result;
#line 130 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 130 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->_child_has_exited;
#line 130 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4151 "TerminalWidget.c"
}

static void
terminal_terminal_widget_set_child_has_exited (TerminalTerminalWidget* self,
                                               gboolean value)
{
	gboolean old_value;
#line 131 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_child_has_exited (self);
#line 131 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 131 "../src/Widgets/TerminalWidget.vala"
		self->priv->_child_has_exited = value;
#line 131 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY]);
#line 4169 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_get_killed (TerminalTerminalWidget* self)
{
	gboolean result;
#line 135 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 135 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->_killed;
#line 135 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4183 "TerminalWidget.c"
}

static void
terminal_terminal_widget_set_killed (TerminalTerminalWidget* self,
                                     gboolean value)
{
	gboolean old_value;
#line 136 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_killed (self);
#line 136 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 136 "../src/Widgets/TerminalWidget.vala"
		self->priv->_killed = value;
#line 136 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY]);
#line 4201 "TerminalWidget.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 170 "../src/Widgets/TerminalWidget.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 170 "../src/Widgets/TerminalWidget.vala"
	return _data4_;
#line 4212 "TerminalWidget.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 170 "../src/Widgets/TerminalWidget.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4222 "TerminalWidget.c"
		TerminalTerminalWidget* self;
#line 170 "../src/Widgets/TerminalWidget.vala"
		self = _data4_->self;
#line 170 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (self);
#line 170 "../src/Widgets/TerminalWidget.vala"
		g_slice_free (Block4Data, _data4_);
#line 4230 "TerminalWidget.c"
	}
}

static void
_terminal_terminal_widget_update_theme_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 182 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_theme ((TerminalTerminalWidget*) self);
#line 4241 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_audible_bell_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 183 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_audible_bell ((TerminalTerminalWidget*) self);
#line 4251 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_theme_g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 184 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_theme ((TerminalTerminalWidget*) self);
#line 4261 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_cursor_shape_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 186 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_cursor_shape ((TerminalTerminalWidget*) self);
#line 4271 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_pointer_focus_gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                                           gdouble x,
                                                                           gdouble y,
                                                                           gpointer self)
{
#line 196 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_pointer_focus ((TerminalTerminalWidget*) self);
#line 4282 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_scroll_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                     gdouble dx,
                                                                     gdouble dy,
                                                                     gpointer self)
{
#line 201 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_scroll ((TerminalTerminalWidget*) self, dx, dy);
#line 4293 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda34_ (TerminalTerminalWidget* self)
{
#line 202 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_delta = 0.0;
#line 4301 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda34__gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                               gpointer self)
{
#line 202 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda34_ ((TerminalTerminalWidget*) self);
#line 4310 "TerminalWidget.c"
}

static gboolean
_terminal_terminal_widget_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self)
{
	gboolean result;
	result = terminal_terminal_widget_key_pressed ((TerminalTerminalWidget*) self, keyval, keycode, state);
#line 207 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4324 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda35_ (TerminalTerminalWidget* self)
{
	GtkEventControllerScroll* _tmp0_;
#line 208 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->scroll_controller;
#line 208 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 4335 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda35__gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                              guint keyval,
                                                                              guint keycode,
                                                                              GdkModifierType state,
                                                                              gpointer self)
{
#line 208 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda35_ ((TerminalTerminalWidget*) self);
#line 4347 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda36_ (TerminalTerminalWidget* self)
{
	GtkEventControllerScroll* _tmp0_;
#line 209 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->scroll_controller;
#line 209 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 4358 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda36__gtk_event_controller_key_focus_out (GtkEventControllerKey* _sender,
                                                                           gpointer self)
{
#line 209 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda36_ ((TerminalTerminalWidget*) self);
#line 4367 "TerminalWidget.c"
}

static gboolean
_terminal_terminal_widget___lambda37_ (TerminalTerminalWidget* self)
{
	gboolean result;
#line 218 "../src/Widgets/TerminalWidget.vala"
	self->priv->modifier_pressed = !self->priv->modifier_pressed;
#line 219 "../src/Widgets/TerminalWidget.vala"
	result = TRUE;
#line 219 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4380 "TerminalWidget.c"
}

static gboolean
__terminal_terminal_widget___lambda37__gtk_event_controller_key_modifiers (GtkEventControllerKey* _sender,
                                                                           GdkModifierType object,
                                                                           gpointer self)
{
	gboolean result;
	result = _terminal_terminal_widget___lambda37_ ((TerminalTerminalWidget*) self);
#line 215 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4392 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_primary_pressed_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                           gint n_press,
                                                                           gdouble x,
                                                                           gdouble y,
                                                                           gpointer self)
{
#line 226 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_primary_pressed ((TerminalTerminalWidget*) self, _sender, n_press, x, y);
#line 4404 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_secondary_released_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                               gint n_press,
                                                                               gdouble x,
                                                                               gdouble y,
                                                                               gpointer self)
{
#line 232 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_secondary_released ((TerminalTerminalWidget*) self, _sender, n_press, x, y);
#line 4416 "TerminalWidget.c"
}

static gboolean
_gtk_event_controller_handle_event_gtk_widget_event (GtkWidget* _sender,
                                                     GdkEvent* event,
                                                     gpointer self)
{
	gboolean result;
	result = gtk_event_controller_handle_event ((GtkEventController*) self, event);
#line 235 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4428 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda38_ (TerminalTerminalWidget* self)
{
	GSimpleAction* _tmp0_;
#line 237 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->copy_action;
#line 237 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp0_, vte_terminal_get_has_selection ((VteTerminal*) self));
#line 4439 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda38__vte_terminal_selection_changed (VteTerminal* _sender,
                                                                       gpointer self)
{
#line 237 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda38_ ((TerminalTerminalWidget*) self);
#line 4448 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda39_ (TerminalTerminalWidget* self)
{
#line 238 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_resized (self, TRUE);
#line 4456 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda39__gtk_widget_size_allocate (GtkWidget* _sender,
                                                                 GtkAllocation* allocation,
                                                                 gpointer self)
{
#line 238 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda39_ ((TerminalTerminalWidget*) self);
#line 4466 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_check_cwd_changed_vte_terminal_contents_changed (VteTerminal* _sender,
                                                                           gpointer self)
{
#line 239 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_check_cwd_changed ((TerminalTerminalWidget*) self);
#line 4475 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                     gint status,
                                                                     gpointer self)
{
#line 240 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_on_child_exited ((TerminalTerminalWidget*) self);
#line 4485 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_setup_menu_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                 GdkEventOwnerChange* event,
                                                                 gpointer self)
{
#line 244 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_setup_menu ((TerminalTerminalWidget*) self);
#line 4495 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda40_ (Block4Data* _data4_)
{
	TerminalTerminalWidget* self;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
#line 242 "../src/Widgets/TerminalWidget.vala"
	self = _data4_->self;
#line 243 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_widget_get_clipboard ((GtkWidget*) self, GDK_SELECTION_CLIPBOARD);
#line 243 "../src/Widgets/TerminalWidget.vala"
	self->priv->clipboard = _tmp0_;
#line 244 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->priv->clipboard;
#line 244 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp1_, "owner-change", (GCallback) _terminal_terminal_widget_setup_menu_gtk_clipboard_owner_change, self, 0);
#line 245 "../src/Widgets/TerminalWidget.vala"
	g_signal_handler_disconnect ((GObject*) self, _data4_->once);
#line 4516 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda40__gtk_widget_realize (GtkWidget* _sender,
                                                           gpointer self)
{
#line 242 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda40_ (self);
#line 4525 "TerminalWidget.c"
}

static void
_vala_array_add1 (GtkTargetEntry* * array,
                  gint* length,
                  gint* size,
                  const GtkTargetEntry* value)
{
#line 254 "../src/Widgets/TerminalWidget.vala"
	if ((*length) == (*size)) {
#line 254 "../src/Widgets/TerminalWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 254 "../src/Widgets/TerminalWidget.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 4540 "TerminalWidget.c"
	}
#line 254 "../src/Widgets/TerminalWidget.vala"
	(*array)[(*length)++] = *value;
#line 4544 "TerminalWidget.c"
}

static void
_vala_array_add2 (GtkTargetEntry* * array,
                  gint* length,
                  gint* size,
                  const GtkTargetEntry* value)
{
#line 255 "../src/Widgets/TerminalWidget.vala"
	if ((*length) == (*size)) {
#line 255 "../src/Widgets/TerminalWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 255 "../src/Widgets/TerminalWidget.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 4559 "TerminalWidget.c"
	}
#line 255 "../src/Widgets/TerminalWidget.vala"
	(*array)[(*length)++] = *value;
#line 4563 "TerminalWidget.c"
}

static void
_vala_array_add3 (GtkTargetEntry* * array,
                  gint* length,
                  gint* size,
                  const GtkTargetEntry* value)
{
#line 256 "../src/Widgets/TerminalWidget.vala"
	if ((*length) == (*size)) {
#line 256 "../src/Widgets/TerminalWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 256 "../src/Widgets/TerminalWidget.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 4578 "TerminalWidget.c"
	}
#line 256 "../src/Widgets/TerminalWidget.vala"
	(*array)[(*length)++] = *value;
#line 4582 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_drag_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       gint x,
                                                                       gint y,
                                                                       GtkSelectionData* selection_data,
                                                                       guint info,
                                                                       guint time_,
                                                                       gpointer self)
{
#line 261 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_drag_received ((TerminalTerminalWidget*) self, context, x, y, selection_data, info, time_);
#line 4597 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda41_ (TerminalTerminalWidget* self)
{
#line 270 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_copy_clipboard ((VteTerminal*) self);
#line 4605 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda41__g_simple_action_activate (GSimpleAction* _sender,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 270 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda41_ ((TerminalTerminalWidget*) self);
#line 4615 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_copy_output_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 275 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_copy_output ((TerminalTerminalWidget*) self);
#line 4625 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_action_clear_screen_g_simple_action_activate (GSimpleAction* _sender,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 280 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_action_clear_screen ((TerminalTerminalWidget*) self);
#line 4635 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_action_reset_g_simple_action_activate (GSimpleAction* _sender,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 285 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_action_reset ((TerminalTerminalWidget*) self);
#line 4645 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda42_ (TerminalTerminalWidget* self)
{
#line 289 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_paste_clipboard ((VteTerminal*) self);
#line 4653 "TerminalWidget.c"
}

static void
__terminal_terminal_widget___lambda42__g_simple_action_activate (GSimpleAction* _sender,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 289 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda42_ ((TerminalTerminalWidget*) self);
#line 4663 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_reload_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 293 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_reload ((TerminalTerminalWidget*) self);
#line 4673 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_scroll_to_command_g_simple_action_activate (GSimpleAction* _sender,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 298 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_scroll_to_command ((TerminalTerminalWidget*) self, _sender, parameter);
#line 4683 "TerminalWidget.c"
}

static void
_vte_terminal_select_all_g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self)
{
#line 302 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_select_all ((VteTerminal*) self);
#line 4693 "TerminalWidget.c"
}

static gchar*
_variant_get1 (GVariant* value)
{
#line 308 "../src/Widgets/TerminalWidget.vala"
	return g_variant_dup_string (value, NULL);
#line 4701 "TerminalWidget.c"
}

static void
_terminal_terminal_widget___lambda43_ (TerminalTerminalWidget* self,
                                       GVariant* p)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 308 "../src/Widgets/TerminalWidget.vala"
	static GQuark _tmp2_label0 = 0;
#line 308 "../src/Widgets/TerminalWidget.vala"
	static GQuark _tmp2_label1 = 0;
#line 308 "../src/Widgets/TerminalWidget.vala"
	static GQuark _tmp2_label2 = 0;
#line 308 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = _variant_get1 (p);
#line 308 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 308 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 308 "../src/Widgets/TerminalWidget.vala"
	g_free (_tmp1_);
#line 308 "../src/Widgets/TerminalWidget.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("in")))) {
#line 308 "../src/Widgets/TerminalWidget.vala"
		switch (0) {
#line 4729 "TerminalWidget.c"
			default:
			{
#line 310 "../src/Widgets/TerminalWidget.vala"
				g_signal_emit_by_name ((VteTerminal*) self, "increase-font-size");
#line 311 "../src/Widgets/TerminalWidget.vala"
				break;
#line 4736 "TerminalWidget.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("out")))) {
#line 308 "../src/Widgets/TerminalWidget.vala"
		switch (0) {
#line 4742 "TerminalWidget.c"
			default:
			{
#line 313 "../src/Widgets/TerminalWidget.vala"
				g_signal_emit_by_name ((VteTerminal*) self, "decrease-font-size");
#line 314 "../src/Widgets/TerminalWidget.vala"
				break;
#line 4749 "TerminalWidget.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("default")))) {
#line 308 "../src/Widgets/TerminalWidget.vala"
		switch (0) {
#line 4755 "TerminalWidget.c"
			default:
			{
#line 316 "../src/Widgets/TerminalWidget.vala"
				terminal_terminal_widget_default_font_size (self);
#line 317 "../src/Widgets/TerminalWidget.vala"
				break;
#line 4762 "TerminalWidget.c"
			}
		}
	}
}

static void
__terminal_terminal_widget___lambda43__g_simple_action_activate (GSimpleAction* _sender,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 307 "../src/Widgets/TerminalWidget.vala"
	_terminal_terminal_widget___lambda43_ ((TerminalTerminalWidget*) self, parameter);
#line 4775 "TerminalWidget.c"
}

static GObject *
terminal_terminal_widget_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TerminalTerminalWidget * self;
	Block4Data* _data4_;
	gint _tmp0_;
	gchar* _tmp1_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp2_;
	GraniteSettings* _tmp3_;
	GraniteSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GtkEventControllerMotion* _tmp14_ = NULL;
	GtkEventControllerMotion* _tmp15_;
	GtkEventControllerScroll* _tmp16_ = NULL;
	GtkEventControllerScroll* _tmp17_;
	GtkEventControllerScroll* _tmp18_;
	GtkEventControllerKey* _tmp19_ = NULL;
	GtkEventControllerKey* _tmp20_;
	GtkEventControllerKey* _tmp21_;
	GtkEventControllerKey* _tmp22_;
	GtkEventControllerKey* _tmp23_;
	GtkGestureMultiPress* _tmp24_ = NULL;
	GtkGestureMultiPress* _tmp25_;
	GtkGestureMultiPress* _tmp26_ = NULL;
	GtkGestureMultiPress* _tmp27_;
	GtkEventControllerKey* _tmp28_;
	gulong _tmp29_;
	GtkTargetEntry uri_entry = {0};
	GtkTargetEntry _tmp30_ = {0};
	GtkTargetEntry string_entry = {0};
	GtkTargetEntry _tmp31_ = {0};
	GtkTargetEntry text_entry = {0};
	GtkTargetEntry _tmp32_ = {0};
	GtkTargetEntry* targets = NULL;
	GtkTargetEntry* _tmp33_;
	gint targets_length1;
	gint _targets_size_;
	GtkTargetEntry _tmp34_;
	GtkTargetEntry _tmp35_;
	GtkTargetEntry _tmp36_;
	GtkTargetEntry* _tmp37_;
	gint _tmp37__length1;
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp38_;
	GSimpleActionGroup* _tmp39_;
	GSimpleAction* _tmp40_;
	GSimpleAction* _tmp41_;
	GSimpleAction* _tmp42_;
	GSimpleActionGroup* _tmp43_;
	GSimpleAction* _tmp44_;
	GSimpleAction* _tmp45_;
	GSimpleAction* _tmp46_;
	GSimpleAction* _tmp47_;
	GSimpleActionGroup* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
	GSimpleAction* _tmp51_;
	GSimpleAction* _tmp52_;
	GSimpleActionGroup* _tmp53_;
	GSimpleAction* _tmp54_;
	GSimpleAction* _tmp55_;
	GSimpleAction* _tmp56_;
	GSimpleAction* _tmp57_;
	GSimpleActionGroup* _tmp58_;
	GSimpleAction* _tmp59_;
	GSimpleAction* _tmp60_;
	GSimpleAction* _tmp61_;
	GSimpleActionGroup* _tmp62_;
	GSimpleAction* _tmp63_;
	GSimpleAction* reload_action = NULL;
	GSimpleAction* _tmp64_;
	GSimpleAction* _tmp65_;
	GSimpleActionGroup* _tmp66_;
	GSimpleAction* _tmp67_;
	GSimpleAction* _tmp68_;
	GSimpleAction* _tmp69_;
	GSimpleAction* _tmp70_;
	GSimpleActionGroup* _tmp71_;
	GSimpleAction* _tmp72_;
	GSimpleAction* select_all_action = NULL;
	GSimpleAction* _tmp73_;
	GSimpleAction* _tmp74_;
	GSimpleActionGroup* _tmp75_;
	GSimpleAction* _tmp76_;
	GSimpleAction* zoom_action = NULL;
	const GVariantType* _tmp77_;
	GSimpleAction* _tmp78_;
	GSimpleAction* _tmp79_;
	GSimpleActionGroup* _tmp80_;
	GSimpleAction* _tmp81_;
#line 170 "../src/Widgets/TerminalWidget.vala"
	parent_class = G_OBJECT_CLASS (terminal_terminal_widget_parent_class);
#line 170 "../src/Widgets/TerminalWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 170 "../src/Widgets/TerminalWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_data4_->_ref_count_ = 1;
#line 170 "../src/Widgets/TerminalWidget.vala"
	_data4_->self = g_object_ref (self);
#line 171 "../src/Widgets/TerminalWidget.vala"
	g_object_set ((VteTerminal*) self, "pointer-autohide", TRUE, NULL);
#line 172 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_terminal_id_counter;
#line 172 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_terminal_id_counter = _tmp0_ + 1;
#line 172 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 172 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->terminal_id);
#line 172 "../src/Widgets/TerminalWidget.vala"
	self->terminal_id = _tmp1_;
#line 173 "../src/Widgets/TerminalWidget.vala"
	self->priv->init_complete = FALSE;
#line 174 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_child_has_exited (self, FALSE);
#line 175 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_killed (self, FALSE);
#line 177 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_audible_bell (self);
#line 178 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_cursor_shape (self);
#line 179 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_theme (self);
#line 181 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = granite_settings_get_default ();
#line 181 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 181 "../src/Widgets/TerminalWidget.vala"
	granite_settings = _tmp3_;
#line 182 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = granite_settings;
#line 182 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::prefers-color-scheme", (GCallback) _terminal_terminal_widget_update_theme_g_object_notify, self, 0);
#line 183 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = terminal_application_settings;
#line 183 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp5_, "changed::audible-bell", (GCallback) _terminal_terminal_widget_update_audible_bell_g_settings_changed, self, 0);
#line 184 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = terminal_application_settings;
#line 184 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp6_, "changed::background", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 185 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = terminal_application_settings;
#line 185 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp7_, "changed::cursor-color", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 186 "../src/Widgets/TerminalWidget.vala"
	_tmp8_ = terminal_application_settings;
#line 186 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp8_, "changed::cursor-shape", (GCallback) _terminal_terminal_widget_update_cursor_shape_g_settings_changed, self, 0);
#line 187 "../src/Widgets/TerminalWidget.vala"
	_tmp9_ = terminal_application_settings;
#line 187 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp9_, "changed::follow-system-style", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 188 "../src/Widgets/TerminalWidget.vala"
	_tmp10_ = terminal_application_settings;
#line 188 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp10_, "changed::foreground", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 189 "../src/Widgets/TerminalWidget.vala"
	_tmp11_ = terminal_application_settings;
#line 189 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp11_, "changed::palette", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 190 "../src/Widgets/TerminalWidget.vala"
	_tmp12_ = terminal_application_settings;
#line 190 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp12_, "changed::prefer-dark-style", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 191 "../src/Widgets/TerminalWidget.vala"
	_tmp13_ = terminal_application_settings;
#line 191 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp13_, "changed::theme", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 193 "../src/Widgets/TerminalWidget.vala"
	_tmp14_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 193 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp14_, GTK_PHASE_CAPTURE);
#line 193 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 193 "../src/Widgets/TerminalWidget.vala"
	self->priv->motion_controller = _tmp14_;
#line 196 "../src/Widgets/TerminalWidget.vala"
	_tmp15_ = self->priv->motion_controller;
#line 196 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp15_, "enter", (GCallback) _terminal_terminal_widget_pointer_focus_gtk_event_controller_motion_enter, self, 0);
#line 198 "../src/Widgets/TerminalWidget.vala"
	_tmp16_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new ((GtkWidget*) self, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 198 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp16_, GTK_PHASE_TARGET);
#line 198 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 198 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_controller = _tmp16_;
#line 201 "../src/Widgets/TerminalWidget.vala"
	_tmp17_ = self->priv->scroll_controller;
#line 201 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp17_, "scroll", (GCallback) _terminal_terminal_widget_scroll_gtk_event_controller_scroll_scroll, self, 0);
#line 202 "../src/Widgets/TerminalWidget.vala"
	_tmp18_ = self->priv->scroll_controller;
#line 202 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp18_, "scroll-end", (GCallback) __terminal_terminal_widget___lambda34__gtk_event_controller_scroll_scroll_end, self, 0);
#line 204 "../src/Widgets/TerminalWidget.vala"
	_tmp19_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 204 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp19_, GTK_PHASE_NONE);
#line 204 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 204 "../src/Widgets/TerminalWidget.vala"
	self->priv->key_controller = _tmp19_;
#line 207 "../src/Widgets/TerminalWidget.vala"
	_tmp20_ = self->priv->key_controller;
#line 207 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp20_, "key-pressed", (GCallback) _terminal_terminal_widget_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 208 "../src/Widgets/TerminalWidget.vala"
	_tmp21_ = self->priv->key_controller;
#line 208 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp21_, "key-released", (GCallback) __terminal_terminal_widget___lambda35__gtk_event_controller_key_key_released, self, 0);
#line 209 "../src/Widgets/TerminalWidget.vala"
	_tmp22_ = self->priv->key_controller;
#line 209 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp22_, "focus-out", (GCallback) __terminal_terminal_widget___lambda36__gtk_event_controller_key_focus_out, self, 0);
#line 215 "../src/Widgets/TerminalWidget.vala"
	_tmp23_ = self->priv->key_controller;
#line 215 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp23_, "modifiers", (GCallback) __terminal_terminal_widget___lambda37__gtk_event_controller_key_modifiers, self, 0);
#line 222 "../src/Widgets/TerminalWidget.vala"
	_tmp24_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 222 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp24_, GTK_PHASE_TARGET);
#line 222 "../src/Widgets/TerminalWidget.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp24_, (guint) 1);
#line 222 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->primary_gesture);
#line 222 "../src/Widgets/TerminalWidget.vala"
	self->priv->primary_gesture = _tmp24_;
#line 226 "../src/Widgets/TerminalWidget.vala"
	_tmp25_ = self->priv->primary_gesture;
#line 226 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp25_, "pressed", (GCallback) _terminal_terminal_widget_primary_pressed_gtk_gesture_multi_press_pressed, self, 0);
#line 228 "../src/Widgets/TerminalWidget.vala"
	_tmp26_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 228 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp26_, GTK_PHASE_TARGET);
#line 228 "../src/Widgets/TerminalWidget.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp26_, (guint) 3);
#line 228 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->secondary_gesture);
#line 228 "../src/Widgets/TerminalWidget.vala"
	self->priv->secondary_gesture = _tmp26_;
#line 232 "../src/Widgets/TerminalWidget.vala"
	_tmp27_ = self->priv->secondary_gesture;
#line 232 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp27_, "released", (GCallback) _terminal_terminal_widget_secondary_released_gtk_gesture_multi_press_released, self, 0);
#line 235 "../src/Widgets/TerminalWidget.vala"
	_tmp28_ = self->priv->key_controller;
#line 235 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "event", (GCallback) _gtk_event_controller_handle_event_gtk_widget_event, (GtkEventController*) _tmp28_, 0);
#line 237 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((VteTerminal*) self, "selection-changed", (GCallback) __terminal_terminal_widget___lambda38__vte_terminal_selection_changed, self, 0);
#line 238 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) __terminal_terminal_widget___lambda39__gtk_widget_size_allocate, self, 0);
#line 239 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((VteTerminal*) self, "contents-changed", (GCallback) _terminal_terminal_widget_check_cwd_changed_vte_terminal_contents_changed, self, 0);
#line 240 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((VteTerminal*) self, "child-exited", (GCallback) _terminal_terminal_widget_on_child_exited_vte_terminal_child_exited, self, 0);
#line 241 "../src/Widgets/TerminalWidget.vala"
	_data4_->once = (gulong) 0;
#line 242 "../src/Widgets/TerminalWidget.vala"
	_tmp29_ = g_signal_connect_data ((GtkWidget*) self, "realize", (GCallback) __terminal_terminal_widget___lambda40__gtk_widget_realize, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 242 "../src/Widgets/TerminalWidget.vala"
	_data4_->once = _tmp29_;
#line 249 "../src/Widgets/TerminalWidget.vala"
	_tmp30_.target = "text/uri-list";
#line 249 "../src/Widgets/TerminalWidget.vala"
	_tmp30_.flags = (guint) GTK_TARGET_OTHER_APP;
#line 249 "../src/Widgets/TerminalWidget.vala"
	_tmp30_.info = (guint) TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST;
#line 249 "../src/Widgets/TerminalWidget.vala"
	uri_entry = _tmp30_;
#line 250 "../src/Widgets/TerminalWidget.vala"
	_tmp31_.target = "STRING";
#line 250 "../src/Widgets/TerminalWidget.vala"
	_tmp31_.flags = (guint) GTK_TARGET_OTHER_APP;
#line 250 "../src/Widgets/TerminalWidget.vala"
	_tmp31_.info = (guint) TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING;
#line 250 "../src/Widgets/TerminalWidget.vala"
	string_entry = _tmp31_;
#line 251 "../src/Widgets/TerminalWidget.vala"
	_tmp32_.target = "text/plain";
#line 251 "../src/Widgets/TerminalWidget.vala"
	_tmp32_.flags = (guint) GTK_TARGET_OTHER_APP;
#line 251 "../src/Widgets/TerminalWidget.vala"
	_tmp32_.info = (guint) TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT;
#line 251 "../src/Widgets/TerminalWidget.vala"
	text_entry = _tmp32_;
#line 253 "../src/Widgets/TerminalWidget.vala"
	_tmp33_ = g_new0 (GtkTargetEntry, 0);
#line 253 "../src/Widgets/TerminalWidget.vala"
	targets = _tmp33_;
#line 253 "../src/Widgets/TerminalWidget.vala"
	targets_length1 = 0;
#line 253 "../src/Widgets/TerminalWidget.vala"
	_targets_size_ = targets_length1;
#line 254 "../src/Widgets/TerminalWidget.vala"
	_tmp34_ = uri_entry;
#line 254 "../src/Widgets/TerminalWidget.vala"
	_vala_array_add1 (&targets, &targets_length1, &_targets_size_, &_tmp34_);
#line 255 "../src/Widgets/TerminalWidget.vala"
	_tmp35_ = string_entry;
#line 255 "../src/Widgets/TerminalWidget.vala"
	_vala_array_add2 (&targets, &targets_length1, &_targets_size_, &_tmp35_);
#line 256 "../src/Widgets/TerminalWidget.vala"
	_tmp36_ = text_entry;
#line 256 "../src/Widgets/TerminalWidget.vala"
	_vala_array_add3 (&targets, &targets_length1, &_targets_size_, &_tmp36_);
#line 258 "../src/Widgets/TerminalWidget.vala"
	_tmp37_ = targets;
#line 258 "../src/Widgets/TerminalWidget.vala"
	_tmp37__length1 = targets_length1;
#line 258 "../src/Widgets/TerminalWidget.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp37_, (gint) _tmp37__length1, GDK_ACTION_COPY);
#line 261 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-received", (GCallback) _terminal_terminal_widget_drag_received_gtk_widget_drag_data_received, self, 0);
#line 262 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_clickable (self, TERMINAL_TERMINAL_WIDGET_REGEX_STRINGS, (gint) G_N_ELEMENTS (TERMINAL_TERMINAL_WIDGET_REGEX_STRINGS));
#line 265 "../src/Widgets/TerminalWidget.vala"
	_tmp38_ = g_simple_action_group_new ();
#line 265 "../src/Widgets/TerminalWidget.vala"
	action_group = _tmp38_;
#line 266 "../src/Widgets/TerminalWidget.vala"
	_tmp39_ = action_group;
#line 266 "../src/Widgets/TerminalWidget.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "term", (GActionGroup*) _tmp39_);
#line 268 "../src/Widgets/TerminalWidget.vala"
	_tmp40_ = g_simple_action_new ("copy", NULL);
#line 268 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_action);
#line 268 "../src/Widgets/TerminalWidget.vala"
	self->priv->copy_action = _tmp40_;
#line 269 "../src/Widgets/TerminalWidget.vala"
	_tmp41_ = self->priv->copy_action;
#line 269 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp41_, FALSE);
#line 270 "../src/Widgets/TerminalWidget.vala"
	_tmp42_ = self->priv->copy_action;
#line 270 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp42_, "activate", (GCallback) __terminal_terminal_widget___lambda41__g_simple_action_activate, self, 0);
#line 271 "../src/Widgets/TerminalWidget.vala"
	_tmp43_ = action_group;
#line 271 "../src/Widgets/TerminalWidget.vala"
	_tmp44_ = self->priv->copy_action;
#line 271 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp43_, (GAction*) _tmp44_);
#line 273 "../src/Widgets/TerminalWidget.vala"
	_tmp45_ = g_simple_action_new ("copy-output", NULL);
#line 273 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_output_action);
#line 273 "../src/Widgets/TerminalWidget.vala"
	self->priv->copy_output_action = _tmp45_;
#line 274 "../src/Widgets/TerminalWidget.vala"
	_tmp46_ = self->priv->copy_output_action;
#line 274 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp46_, FALSE);
#line 275 "../src/Widgets/TerminalWidget.vala"
	_tmp47_ = self->priv->copy_output_action;
#line 275 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp47_, "activate", (GCallback) _terminal_terminal_widget_copy_output_g_simple_action_activate, self, 0);
#line 276 "../src/Widgets/TerminalWidget.vala"
	_tmp48_ = action_group;
#line 276 "../src/Widgets/TerminalWidget.vala"
	_tmp49_ = self->priv->copy_output_action;
#line 276 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp48_, (GAction*) _tmp49_);
#line 278 "../src/Widgets/TerminalWidget.vala"
	_tmp50_ = g_simple_action_new ("clear-screen", NULL);
#line 278 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->clear_screen_action);
#line 278 "../src/Widgets/TerminalWidget.vala"
	self->priv->clear_screen_action = _tmp50_;
#line 279 "../src/Widgets/TerminalWidget.vala"
	_tmp51_ = self->priv->clear_screen_action;
#line 279 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp51_, TRUE);
#line 280 "../src/Widgets/TerminalWidget.vala"
	_tmp52_ = self->priv->clear_screen_action;
#line 280 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp52_, "activate", (GCallback) _terminal_terminal_widget_action_clear_screen_g_simple_action_activate, self, 0);
#line 281 "../src/Widgets/TerminalWidget.vala"
	_tmp53_ = action_group;
#line 281 "../src/Widgets/TerminalWidget.vala"
	_tmp54_ = self->priv->clear_screen_action;
#line 281 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp53_, (GAction*) _tmp54_);
#line 283 "../src/Widgets/TerminalWidget.vala"
	_tmp55_ = g_simple_action_new ("reset", NULL);
#line 283 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->reset_action);
#line 283 "../src/Widgets/TerminalWidget.vala"
	self->priv->reset_action = _tmp55_;
#line 284 "../src/Widgets/TerminalWidget.vala"
	_tmp56_ = self->priv->reset_action;
#line 284 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp56_, TRUE);
#line 285 "../src/Widgets/TerminalWidget.vala"
	_tmp57_ = self->priv->reset_action;
#line 285 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp57_, "activate", (GCallback) _terminal_terminal_widget_action_reset_g_simple_action_activate, self, 0);
#line 286 "../src/Widgets/TerminalWidget.vala"
	_tmp58_ = action_group;
#line 286 "../src/Widgets/TerminalWidget.vala"
	_tmp59_ = self->priv->reset_action;
#line 286 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp58_, (GAction*) _tmp59_);
#line 288 "../src/Widgets/TerminalWidget.vala"
	_tmp60_ = g_simple_action_new ("paste", NULL);
#line 288 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->paste_action);
#line 288 "../src/Widgets/TerminalWidget.vala"
	self->priv->paste_action = _tmp60_;
#line 289 "../src/Widgets/TerminalWidget.vala"
	_tmp61_ = self->priv->paste_action;
#line 289 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp61_, "activate", (GCallback) __terminal_terminal_widget___lambda42__g_simple_action_activate, self, 0);
#line 290 "../src/Widgets/TerminalWidget.vala"
	_tmp62_ = action_group;
#line 290 "../src/Widgets/TerminalWidget.vala"
	_tmp63_ = self->priv->paste_action;
#line 290 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp62_, (GAction*) _tmp63_);
#line 292 "../src/Widgets/TerminalWidget.vala"
	_tmp64_ = g_simple_action_new ("reload", NULL);
#line 292 "../src/Widgets/TerminalWidget.vala"
	reload_action = _tmp64_;
#line 293 "../src/Widgets/TerminalWidget.vala"
	_tmp65_ = reload_action;
#line 293 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp65_, "activate", (GCallback) _terminal_terminal_widget_reload_g_simple_action_activate, self, 0);
#line 294 "../src/Widgets/TerminalWidget.vala"
	_tmp66_ = action_group;
#line 294 "../src/Widgets/TerminalWidget.vala"
	_tmp67_ = reload_action;
#line 294 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp66_, (GAction*) _tmp67_);
#line 296 "../src/Widgets/TerminalWidget.vala"
	_tmp68_ = g_simple_action_new ("scroll-to-command", NULL);
#line 296 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_to_command_action);
#line 296 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_to_command_action = _tmp68_;
#line 297 "../src/Widgets/TerminalWidget.vala"
	_tmp69_ = self->priv->scroll_to_command_action;
#line 297 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp69_, FALSE);
#line 298 "../src/Widgets/TerminalWidget.vala"
	_tmp70_ = self->priv->scroll_to_command_action;
#line 298 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp70_, "activate", (GCallback) _terminal_terminal_widget_scroll_to_command_g_simple_action_activate, self, 0);
#line 299 "../src/Widgets/TerminalWidget.vala"
	_tmp71_ = action_group;
#line 299 "../src/Widgets/TerminalWidget.vala"
	_tmp72_ = self->priv->scroll_to_command_action;
#line 299 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp71_, (GAction*) _tmp72_);
#line 301 "../src/Widgets/TerminalWidget.vala"
	_tmp73_ = g_simple_action_new ("select-all", NULL);
#line 301 "../src/Widgets/TerminalWidget.vala"
	select_all_action = _tmp73_;
#line 302 "../src/Widgets/TerminalWidget.vala"
	_tmp74_ = select_all_action;
#line 302 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp74_, "activate", (GCallback) _vte_terminal_select_all_g_simple_action_activate, (VteTerminal*) self, 0);
#line 303 "../src/Widgets/TerminalWidget.vala"
	_tmp75_ = action_group;
#line 303 "../src/Widgets/TerminalWidget.vala"
	_tmp76_ = select_all_action;
#line 303 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp75_, (GAction*) _tmp76_);
#line 306 "../src/Widgets/TerminalWidget.vala"
	_tmp77_ = G_VARIANT_TYPE_STRING;
#line 306 "../src/Widgets/TerminalWidget.vala"
	_tmp78_ = g_simple_action_new ("zoom", _tmp77_);
#line 306 "../src/Widgets/TerminalWidget.vala"
	zoom_action = _tmp78_;
#line 307 "../src/Widgets/TerminalWidget.vala"
	_tmp79_ = zoom_action;
#line 307 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp79_, "activate", (GCallback) __terminal_terminal_widget___lambda43__g_simple_action_activate, self, 0);
#line 320 "../src/Widgets/TerminalWidget.vala"
	_tmp80_ = action_group;
#line 320 "../src/Widgets/TerminalWidget.vala"
	_tmp81_ = zoom_action;
#line 320 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) _tmp80_, (GAction*) _tmp81_);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (zoom_action);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (select_all_action);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (reload_action);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (action_group);
#line 170 "../src/Widgets/TerminalWidget.vala"
	targets = (g_free (targets), NULL);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (granite_settings);
#line 170 "../src/Widgets/TerminalWidget.vala"
	block4_data_unref (_data4_);
#line 170 "../src/Widgets/TerminalWidget.vala"
	_data4_ = NULL;
#line 170 "../src/Widgets/TerminalWidget.vala"
	return obj;
#line 5301 "TerminalWidget.c"
}

static void
terminal_terminal_widget_class_init (TerminalTerminalWidgetClass * klass,
                                     gpointer klass_data)
{
#line 21 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_type_class_adjust_private_offset (klass, &TerminalTerminalWidget_private_offset);
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->copy_clipboard = (void (*) (VteTerminal*)) terminal_terminal_widget_real_copy_clipboard;
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->paste_clipboard = (void (*) (VteTerminal*)) terminal_terminal_widget_real_paste_clipboard;
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->increase_font_size = (void (*) (VteTerminal*)) terminal_terminal_widget_real_increase_font_size;
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->decrease_font_size = (void (*) (VteTerminal*)) terminal_terminal_widget_real_decrease_font_size;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_terminal_widget_get_property;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_terminal_widget_set_property;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = terminal_terminal_widget_constructor;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_terminal_widget_finalize;
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY] = g_param_spec_string ("current-working-directory", "current-working-directory", "current-working-directory", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_PROGRAM_STRING_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_PROGRAM_STRING_PROPERTY] = g_param_spec_string ("program-string", "program-string", "program-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY] = g_param_spec_boolean ("resized", "resized", "resized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_MAIN_WINDOW_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_MAIN_WINDOW_PROPERTY] = g_param_spec_object ("main-window", "main-window", "main-window", TERMINAL_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY] = g_param_spec_string ("tab-label", "tab-label", "tab-label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY] = g_param_spec_boolean ("child-has-exited", "child-has-exited", "child-has-exited", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY] = g_param_spec_boolean ("killed", "killed", "killed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_signals[TERMINAL_TERMINAL_WIDGET_CWD_CHANGED_SIGNAL] = g_signal_new ("cwd-changed", TERMINAL_TYPE_TERMINAL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 5344 "TerminalWidget.c"
}

static void
terminal_terminal_widget_instance_init (TerminalTerminalWidget * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
#line 21 "../src/Widgets/TerminalWidget.vala"
	self->priv = terminal_terminal_widget_get_instance_private (self);
#line 30 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = g_strdup ("");
#line 30 "../src/Widgets/TerminalWidget.vala"
	self->priv->_current_working_directory = _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
	self->priv->_program_string = NULL;
#line 149 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_command_start_row = (glong) 0;
#line 150 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_command_end_row = (glong) 0;
#line 151 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 159 "../src/Widgets/TerminalWidget.vala"
	self->priv->modifier_pressed = FALSE;
#line 160 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_delta = 0.0;
#line 5370 "TerminalWidget.c"
}

static void
terminal_terminal_widget_finalize (GObject * obj)
{
	TerminalTerminalWidget * self;
#line 21 "../src/Widgets/TerminalWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 29 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->terminal_id);
#line 30 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->priv->_current_working_directory);
#line 31 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->priv->_program_string);
#line 48 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->link_uri);
#line 141 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_action);
#line 142 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_output_action);
#line 143 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->clear_screen_action);
#line 144 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->reset_action);
#line 145 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->paste_action);
#line 146 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_to_command_action);
#line 153 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 154 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 155 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 156 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->primary_gesture);
#line 157 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->secondary_gesture);
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (terminal_terminal_widget_parent_class)->finalize (obj);
#line 5411 "TerminalWidget.c"
}

static GType
terminal_terminal_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalTerminalWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_terminal_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalTerminalWidget), 0, (GInstanceInitFunc) terminal_terminal_widget_instance_init, NULL };
	GType terminal_terminal_widget_type_id;
	terminal_terminal_widget_type_id = g_type_register_static (vte_terminal_get_type (), "TerminalTerminalWidget", &g_define_type_info, 0);
	TerminalTerminalWidget_private_offset = g_type_add_instance_private (terminal_terminal_widget_type_id, sizeof (TerminalTerminalWidgetPrivate));
	return terminal_terminal_widget_type_id;
}

GType
terminal_terminal_widget_get_type (void)
{
	static volatile gsize terminal_terminal_widget_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_widget_type_id__once)) {
		GType terminal_terminal_widget_type_id;
		terminal_terminal_widget_type_id = terminal_terminal_widget_get_type_once ();
		g_once_init_leave (&terminal_terminal_widget_type_id__once, terminal_terminal_widget_type_id);
	}
	return terminal_terminal_widget_type_id__once;
}

static void
_vala_terminal_terminal_widget_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	TerminalTerminalWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 21 "../src/Widgets/TerminalWidget.vala"
	switch (property_id) {
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_string (value, terminal_terminal_widget_get_current_working_directory (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_PROGRAM_STRING_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_string (value, terminal_terminal_widget_get_program_string (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_boolean (value, terminal_terminal_widget_get_resized (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_MAIN_WINDOW_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_object (value, terminal_terminal_widget_get_main_window (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_string (value, terminal_terminal_widget_get_tab_label (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_boolean (value, terminal_terminal_widget_get_child_has_exited (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_boolean (value, terminal_terminal_widget_get_killed (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5488 "TerminalWidget.c"
		default:
#line 21 "../src/Widgets/TerminalWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5494 "TerminalWidget.c"
	}
}

static void
_vala_terminal_terminal_widget_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	TerminalTerminalWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 21 "../src/Widgets/TerminalWidget.vala"
	switch (property_id) {
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_current_working_directory (self, g_value_get_string (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_PROGRAM_STRING_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_program_string (self, g_value_get_string (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_resized (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_MAIN_WINDOW_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_main_window (self, g_value_get_object (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_tab_label (self, g_value_get_string (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_child_has_exited (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_killed (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5550 "TerminalWidget.c"
		default:
#line 21 "../src/Widgets/TerminalWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5556 "TerminalWidget.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

